/***************************************************************************
 *	actree: Athena Widget  Code Conveterterĥ꡼¤
 *		
 *			Date. 1995/11/18 -- 1995/12/29
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			JIS X0208-1983/1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************************
 *	øɸ饤֥Υ󥯥롼ɥե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <errno.h>
/*************************************
 *	X Toolkit Υ󥯥롼ɥե
 *************************************/
#include <X11/Intrinsic.h>		/* Intrinsics Definitions */
#include <X11/StringDefs.h>		/* Standard Name-String definitions */
/***********************************************
 *	Xt Intrinsics 饹Υ󥯥롼ɥե
 ***********************************************/
#include <X11/Composite.h>
#include <X11/Core.h>
#include <X11/Shell.h>
/*****************************************
 *	Athena Widget Υ󥯥롼ɥե
 *****************************************/
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Grip.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Panner.h>
#include <X11/Xaw/Porthole.h>
#include <X11/Xaw/Tree.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/StripChart.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>
/**************************************
 *	acconv ȼΥ󥯥롼ɥե
 **************************************/
#include "acconv.h"
#include "file_sel.h"

/**************************************
 *	ǡ
 *		SamenameCheckInfomation
 **************************************/
typedef struct samenameCheckInfomation {
	PartsTree *myParts;
	String newVariableName;
} SamenameCheckInfomation;

/**************************************************************************
 *	Хѿ
 *		load_fp:			եɤ߹ѥեݥ
 *		save_fp:			ե񤭹ѥեݥ
 *		CurrentParts:		ߤ
 *		CurrentAwParts:		̤
 *		renamePopdownInfo:	͡ॷݥåץ󤹤뤿ι¤
 *		currentWidgetName:	ߤΥå̾
 *		mguiList:			åȼѤΥꥹ
 *		mguiTree:			ĥ꡼ɽΥå
 *		rWidgetName:		å̾Υ͡ѤTextå
 *		rClassName:			͡Υ饹̾ɽѤTextå
 *		rVariableName:		ѿ̾Υ͡ѤTextå
 ***************************************************************************/
FILE *load_fp;
FILE *save_fp;
PartsTree *CurrentParts = NULL;
AWidgetInfo *CurrentAwParts = NULL;
XtPopdownIDRec renamePopdownInfo;
String currentWidgetName;
extern Widget mguiList;
extern Widget mguiTree;
Widget rWidgetName, rClassName, rVariableName;

/***************************************************
 *	ХѿʥեΤͭ
 ***************************************************/
static SamenameCheckInfomation originalWidget;

/**************************************
 *	ץȥ
 **************************************/
void widgetCreater(AWidgetInfo *myWidget, PartsTree *parts);
void shellCreater(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasParent(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasChild(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasFamily(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasNoFamily(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasNormalChild(AWidgetInfo *myWidget, PartsTree *parts);
Boolean partsExist(AWidgetInfo *myWidget, PartsTree *parts);
Boolean alwaysMakable(AWidgetInfo *myWidget, PartsTree *parts);
Boolean alwaysDismakable(AWidgetInfo *myWidget, PartsTree *parts);
void makableObject(PartsTree *parts);
void partsRenewal(PartsTree *parts);

char *argWidgetName(PartsTree *parts);
char *argClassName(PartsTree *parts);
char *widgetAndClassName(PartsTree *parts);
char *widgetAndVariable(PartsTree *parts);

char *(*defaultLabel)(PartsTree *parts) = argWidgetName;

/**************************************************************************
 *	argumentArrayProc[]ʴ󤫤ʸؿʷ
 *	
 *		char *(*argumentArrayProc[])(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʴ
 *	֤
 *		NULL:		顼
 *		NULLʳ:	ʸ
 *	
 *		ϡʴ󤫤ʸؿؤΥݥ
 *		ǤºݤˤϡźˤäƳμ̤
 *		ޤźϡNoArg(0) ʾǡVariableTypeNum ̤
 *		ʤޤ
 *		
 *		źΰ̣
 *	
 *		μ̻			ΰ̣
 *	
 *		NoArg = 0:				źʤźνüѡ
 *		ArgWidget:				åѿ̾
 *		ArgWidgetName:			å̾
 *		ArgWidgetClass:			饹ѿ̾
 *		ArgParent:				ƥåѿ̾
 *		ArgAppContext:			ץꥱ󥳥ƥѿ̾
 *		ArgApplicationClass:	ץꥱ󥯥饹̾
 *		VariableTypeNum:		ϰϥС͡ϰϳѡ
 *	
 *		ͤбơġźѤδؿ뤵롣
 *		
 *	Ȼ
 *	
 *		μ̻			źѤδؿ
 *	
 *		NoArg:					char *noArg(PartsTree *parts);
 *		ArgWidget:				char *argWidget(PartsTree *parts);
 *		ArgWidgetName:			char *argWidgetName(PartsTree *parts);
 *		ArgWidgetClass:			char *argWidgetClass(PartsTree *parts);
 *		ArgParent:				char *argParent(PartsTree *parts);
 *		ArgAppContext:			char *argAppContext(PartsTree *parts);
 *		ArgApplicationClass:	char *argApplicationClass(PartsTree *parts);
 *		VariableTypeNum:		
 *	
 *		
 *		źѤδؿ
 *			char *noArg(PartsTree *parts);				ʤ
 *			char *argWidget(PartsTree *parts);			åѿ̾
 *			char *argWidgetName(PartsTree *parts);		å̾
 *			char *argWidgetClass(PartsTree *parts);		饹ѿ̾
 *			char *argParent(PartsTree *parts);			ƥåѿ̾
 *			char *argAppContext(PartsTree *parts);
 *										ץꥱ󥳥ƥѿ̾
 *			char *argApplicationClass(PartsTree *parts);
 *												ץꥱ󥯥饹̾
 ***************************************************************************/
char *(*argumentArrayProc[])(PartsTree *parts) = {
	noArg, argWidget, argWidgetName, argWidgetClass,
	argParent, argAppContext, argApplicationClass
};

static char **widgetList = NULL;
static AWidgetInfo **awidgetInfo = NULL;
StringsLink *sourceList = NULL;
StringsLink *copyBufferList = NULL;

/**************************************************************************
 *	åȡʥ֥ȡ˺ؿξ
 *		
 *		ξϡذ١شؿʸ١ʴ
 *		ʸؿȤδؿؤΥݥ٤Ǥ
 *		ޤ
 *
 *	  ؿʸ
 *		sprintf() ǽեޥåȲʸǤ
 *		
 *	  
 *		argumentArrayProc[] ź˻Ѥơʴ󤫤ʸ
 *		ޤμΤϡؿؤΥݥʤΤǡʲΤ褦
 *		ˤơʴ󤫤ʸޤ
 *		
 *		string = argumentArrayProc[createNormalArgs[argc]])(parts);
 *		
 *		ǡ¤
 *			󨬨
 *			   ArgWidget  
 *			
 *			ArgWidgetName 
 *			
 *			ArgWidgetClass
 *			
 *			   ArgParent  
 *			
 *			     NoArg     κǸˤϡNoArg ֤
 *			
 *		
 *	  ʸ̣ȻѤ
 *		
 *	
 *		Ư				ؿʸ		
 *	
 *		ץꥱ 	createApplication	createApplicationArgs[]
 *		ƥȺ
 *	
 *					   createShell		createShellArgs[]
 *	
 *		åȺ	  createNormal		createNormalArgs[]
 *	
 *		
 *		ץꥱ󥳥ƥȤκˤϡXtVaAppInitialize() 
 *		ޤ
 *		
 *		ˤϡXtVaCreatePopupShell() Ѥޤ
 *		
 *		åȺˤϡXtVaCreateManagedWidget() Ѥޤ
 *		
 ***************************************************************************/
char createApplication[] = 
	"\t%s = XtVaAppInitialize(\n"
	"\t\t\t\t&app_context,\n"
	"\t\t\t\t\"%s\",\n"
	"\t\t\t\tNULL, 0,\n"
	"\t\t\t\t&argc, argv,\n"
	"\t\t\t\tNULL, \n"
	"\t\t\t\tNULL);\n";
int createApplicationArgs[] = 
	{ArgWidget, ArgApplicationClass, NoArg};

char createShell[] = 
	"\t%s = XtVaCreatePopupShell(\n"
	"\t\t\t\t\"%s\",\n"
	"\t\t\t\t%s,\n"
	"\t\t\t\t%s,\n"
	"\t\t\t\tNULL);\n";
int createShellArgs[] = 
	{ArgWidget, ArgWidgetName, ArgWidgetClass, ArgParent, NoArg};

char createNormal[] = 
	"\t%s = XtVaCreateManagedWidget(\n"
	"\t\t\t\t\"%s\",\n"
	"\t\t\t\t%s,\n"
	"\t\t\t\t%s,\n"
	"\t\t\t\tNULL);\n";
int createNormalArgs[] = 
	{ArgWidget, ArgWidgetName, ArgWidgetClass, ArgParent, NoArg};

/**************************************************************************
 *	widgetSet: åȼξ
 *		
 *	Сѿ
 *		publicInclude:	ѥ֥å󥯥롼ɡեʸ
 *		className:		饹̾ʸ
 *		variableName:	ѿ̾ʥ饹ݥ󥿡ˡʸ
 *		partsClass:		饹ݥ
 *		instance:		󥹥󥹲եޥåʸ
 *		argTypes:		
 *		childExist:		ҥåȤμ¸
 *		type:			ʼ
 *		remakable:		ƹǽȽؿ
 *		creatable:		ĥ꡼¤ǽȽؿ
 *		widgetCreation:	ʺؿ
 *		id:				̤
 *		
 *	
 *	
 *			ѿ		б륯饹	饹μ	åȤμ
 *	
 *		widgetSet[0]	Composite			Xt			󥹥󥹲Բ
 *		widgetSet[1]	Box					Xaw			å
 *		widgetSet[2]	Constraint			Xt			󥹥󥹲Բ
 *		widgetSet[3]	Form				Xaw			å
 *		widgetSet[4]	Dialog				Xaw			å
 *		widgetSet[5]	Viewport			Xaw			å
 *		widgetSet[6]	Paned				Xaw			å
 *		widgetSet[7]	Tree				Xaw			å
 *		widgetSet[8]	Porthole			Xaw			å
 *		widgetSet[9]	OverrideShell		Xt			륦å
 *		widgetSet[10]	SimpleMenu			Xaw			륦å
 *		widgetSet[11]	TopLevelShell		Xt			륦å
 *		widgetSet[12]	ApplicationShell	Xt			ץꥱ
 *		widgetSet[13]	TransientShell		Xt			륦å
 *		widgetSet[14]	Simple				Xaw			󥹥󥹲Բ
 *		widgetSet[15]	Grip				Xaw			å
 *		widgetSet[16]	Label				Xaw			å
 *		widgetSet[17]	Command				Xaw			å
 *		widgetSet[18]	MenuButton			Xaw			å
 *		widgetSet[19]	Repeater			Xaw			å
 *		widgetSet[20]	Toggle				Xaw			å
 *		widgetSet[21]	List				Xaw			å
 *		widgetSet[22]	Panner				Xaw			å
 *		widgetSet[23]	Scrollbar			Xaw			å
 *		widgetSet[24]	StripChart			Xaw			å
 *		widgetSet[25]	Text				Xaw			å
 *		widgetSet[26]	Sme					Xaw			å
 *		widgetSet[27]	SmeBSB				Xaw			å
 *		widgetSet[28]	SmeLine				Xaw			å
 *	
 *		
 *	ǡ¤
 *		
 *		
 *		 publicInclude  ʸ󡡡
 *		
 *		 className  ʸ󡡡
 *		
 *		  variableName  ʸ󡡡
 *		
 *		   partsClass   饹ݥ󥿨
 *		󥹥󥹲
 *		    instance    եޥåʸ
 *		
 *		    argTypes    󨬨
 *		   ArgWidget  
 *		   childExist   
 *		ArgWidgetName 
 *		      type      
 *		ArgWidgetClass
 *		   remakable()  ؿؤΥݥ󥿨
 *		   ArgParent  
 *		   creatable()  ؿؤΥݥ󥿨
 *		     NoArg    
 *		  realizable()  ؿؤΥݥ󥿨
 *		
 *		widgetCreation()ؿؤΥݥ󥿨
 *		
 *		 id 
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 ***************************************************************************/
AWidgetInfo widgetSet[] = {
	{
		"#include <X11/Composite.h>", 	/* 󥯥롼ɡե */
		"Composite", 					/* 饹̾ */
		"compositeWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&compositeWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		NULL, 							/* 󥹥󥹲եޥåʸ */
		NULL, 							/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		MetaClass, 						/* ʼ */
		NULL, 							/* ƹǽȽؿ */
		NULL, 							/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		NULL							/* ʺؿ */
	}, {
		"#include <X11/Xaw/Box.h>",  	/* 󥯥롼ɡե */
		"Box", 							/* 饹̾ */
		"boxWidgetClass", 				/* ѿ̾ʥ饹ݥ󥿡 */
		&boxWidgetClass, 				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		MultiChild,						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasFamily, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Constraint.h>",  /* 󥯥롼ɡե */
		"Constraint", 					/* 饹̾ */
		"constraintWidgetClass",		/* ѿ̾ʥ饹ݥ󥿡 */
		&constraintWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		NULL, 							/* 󥹥󥹲եޥåʸ */
		NULL, 							/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		MetaClass, 						/* ʼ */
		NULL, 							/* ƹǽȽؿ */
		NULL, 							/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		NULL							/* ʺؿ */
	}, {
		"#include <X11/Xaw/Form.h>", 	/* 󥯥롼ɡե */
		"Form", 						/* 饹̾ */
		"formWidgetClass",				/* ѿ̾ʥ饹ݥ󥿡 */
		&formWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		MultiChild,						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Dialog.h>", 	/* 󥯥롼ɡե */
		"Dialog", 						/* 饹̾ */
		"dialogWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&dialogWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		MultiChild,						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Viewport.h>",/* 󥯥롼ɡե */
		"Viewport", 					/* 饹̾ */
		"viewportWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&viewportWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		MultiChild,						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasFamily, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Paned.h>", 	/* 󥯥롼ɡե */
		"Paned", 						/* 饹̾ */
		"panedWidgetClass",				/* ѿ̾ʥ饹ݥ󥿡 */
		&panedWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		MultiChild,						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasFamily, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Tree.h>", 	/* 󥯥롼ɡե */
		"Tree", 						/* 饹̾ */
		"treeWidgetClass",				/* ѿ̾ʥ饹ݥ󥿡 */
		&treeWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		MultiChild,						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Porthole.h>",/* 󥯥롼ɡե */
		"Porthole", 					/* 饹̾ */
		"portholeWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&portholeWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		OneChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Shell.h>", 		/* 󥯥롼ɡե */
		"OverrideShell", 				/* 饹̾ */
		"overrideShellWidgetClass",		/* ѿ̾ʥ饹ݥ󥿡 */
		&overrideShellWidgetClass,		/* 饹ѿʥ饹ݥ󥿡 */
		createShell, 					/* 󥹥󥹲եޥåʸ */
		createShellArgs, 				/* 󥹥󥹲 */
		OneChild, 						/* ҥåȤμ¸ */
		ShellWidget,					/* ʼ */
		hasFamily, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		hasNormalChild, 				/* åȼ¸ǽȽؿ */
		shellCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/SimpleMenu.h>", 	/* 󥯥롼ɡե */
		"SimpleMenu", 					/* 饹̾ */
		"simpleMenuWidgetClass",		/* ѿ̾ʥ饹ݥ󥿡 */
		&simpleMenuWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createShell, 					/* 󥹥󥹲եޥåʸ */
		createShellArgs, 				/* 󥹥󥹲 */
		OneChild, 						/* ҥåȤμ¸ */
		SimpleMenu,						/* ʼ */
		hasFamily, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		shellCreater 					/* ʺؿ */
	}, {
		"#include <X11/Shell.h>", 		/* 󥯥롼ɡե */
		"TopLevelShell", 				/* 饹̾ */
		"topLevelShellWidgetClass",		/* ѿ̾ʥ饹ݥ󥿡 */
		&topLevelShellWidgetClass,		/* 饹ѿʥ饹ݥ󥿡 */
		createShell, 					/* 󥹥󥹲եޥåʸ */
		createShellArgs, 				/* 󥹥󥹲 */
		OneChild, 						/* ҥåȤμ¸ */
		ShellWidget,					/* ʼ */
		hasFamily, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		hasNormalChild, 				/* åȼ¸ǽȽؿ */
		shellCreater 					/* ʺؿ */
	}, {
		"#include <X11/Intrinsic.h>\n"
		"#include <X11/StringDefs.h>", 	/* 󥯥롼ɡե */
		"ApplicationShell", 			/* 饹̾ */
		"applicationShellWidgetClass",	/* ѿ̾ʥ饹ݥ󥿡 */
		&applicationShellWidgetClass,	/* 饹ѿʥ饹ݥ󥿡 */
		createApplication, 				/* 󥹥󥹲եޥåʸ */
		createApplicationArgs, 			/* 󥹥󥹲 */
		OneChild, 						/* ҥåȤμ¸ */
		ShellWidget,					/* ʼ */
		hasChild, 						/* ƹǽȽؿ */
		hasNoFamily, 					/* ĥ꡼¤ǽȽؿ */
		hasNormalChild, 				/* åȼ¸ǽȽؿ */
		shellCreater 					/* ʺؿ */
	}, {
		"#include <X11/Shell.h>", 		/* 󥯥롼ɡե */
		"TransientShell", 				/* 饹̾ */
		"transientShellWidgetClass",	/* ѿ̾ʥ饹ݥ󥿡 */
		&transientShellWidgetClass,		/* 饹ѿʥ饹ݥ󥿡 */
		createShell, 					/* 󥹥󥹲եޥåʸ */
		createShellArgs, 				/* 󥹥󥹲 */
		OneChild, 						/* ҥåȤμ¸ */
		ShellWidget,					/* ʼ */
		hasFamily, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		hasNormalChild, 				/* åȼ¸ǽȽؿ */
		shellCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Simple.h>",  /* 󥯥롼ɡե */
		"Simple", 						/* 饹̾ */
		"simpleWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&simpleWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		NULL, 							/* 󥹥󥹲եޥåʸ */
		NULL, 							/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		NULL, 							/* ƹǽȽؿ */
		NULL, 							/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		NULL							/* ʺؿ */
	}, {
		"#include <X11/Xaw/Grip.h>",  	/* 󥯥롼ɡե */
		"Grip", 						/* 饹̾ */
		"gripWidgetClass",				/* ѿ̾ʥ饹ݥ󥿡 */
		&gripWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Label.h>",  	/* 󥯥롼ɡե */
		"Label", 						/* 饹̾ */
		"labelWidgetClass",				/* ѿ̾ʥ饹ݥ󥿡 */
		&labelWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Command.h>", /* 󥯥롼ɡե */
		"Command", 						/* 饹̾ */
		"commandWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&commandWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/MenuButton.h>",  /* 󥯥롼ɡե */
		"MenuButton", 					/* 饹̾ */
		"menuButtonWidgetClass",		/* ѿ̾ʥ饹ݥ󥿡 */
		&menuButtonWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Repeater.h>",/* 󥯥롼ɡե */
		"Repeater", 					/* 饹̾ */
		"repeaterWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&repeaterWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Toggle.h>",  /* 󥯥롼ɡե */
		"Toggle", 						/* 饹̾ */
		"toggleWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&toggleWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/List.h>",  	/* 󥯥롼ɡե */
		"List", 						/* 饹̾ */
		"listWidgetClass",				/* ѿ̾ʥ饹ݥ󥿡 */
		&listWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Panner.h>",  /* 󥯥롼ɡե */
		"Panner", 						/* 饹̾ */
		"pannerWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&pannerWidgetClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Scrollbar.h>",	/* 󥯥롼ɡե */
		"Scrollbar", 					/* 饹̾ */
		"scrollbarWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&scrollbarWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/StripChart.h>", 	/* 󥯥롼ɡե */
		"StripChart", 					/* 饹̾ */
		"stripChartWidgetClass",		/* ѿ̾ʥ饹ݥ󥿡 */
		&stripChartWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/AsciiText.h>\n"
		"#include <X11/Xaw/Text.h>\n"
		"#include <X11/Xaw/TextSrc.h>\n"
		"#include <X11/Xaw/TextSink.h>\n"
		"#include <X11/Xaw/AsciiSrc.h>\n"
		"#include <X11/Xaw/AsciiSink.h>\n",  /* 󥯥롼ɡե */
		"Text", 						/* 饹̾ */
		"asciiTextWidgetClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&asciiTextWidgetClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		NormalWidget,					/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/Sme.h>",  	/* 󥯥롼ɡե */
		"Sme", 							/* 饹̾ */
		"smeObjectClass",				/* ѿ̾ʥ饹ݥ󥿡 */
		&smeObjectClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		SmeObject,						/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/SmeBSB.h>",  /* 󥯥롼ɡե */
		"SmeBSB", 						/* 饹̾ */
		"smeBSBObjectClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&smeBSBObjectClass,				/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		SmeObject,						/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}, {
		"#include <X11/Xaw/SmeLine.h>", /* 󥯥롼ɡե */
		"SmeLine", 						/* 饹̾ */
		"smeLineObjectClass",			/* ѿ̾ʥ饹ݥ󥿡 */
		&smeLineObjectClass,			/* 饹ѿʥ饹ݥ󥿡 */
		createNormal, 					/* 󥹥󥹲եޥåʸ */
		createNormalArgs, 				/* 󥹥󥹲 */
		NoChild, 						/* ҥåȤμ¸ */
		SmeObject,						/* ʼ */
		hasParent, 						/* ƹǽȽؿ */
		partsExist, 					/* ĥ꡼¤ǽȽؿ */
		NULL, 							/* åȼ¸ǽȽؿ */
		widgetCreater 					/* ʺؿ */
	}
};

/***************************************************************************
 *	PartsAllocʴѤΥݤޤ
 *	
 *		PartsTree *PartsAlloc(void);
 *	֤
 *		NULL:		顼ʥ­
 *		NULLʳ:	Ƥ줿
 *	
 *		γȽԤ
 *		
 *		
 *		ݤꨭ
 *		
 *		
 *		
 *		 widgetName  NULL
 *		
 *		variableName NULL
 *		
 *		  className  NULL
 *		
 *		 partsWidget NULL
 *		
 *		 treeWidget  NULL
 *		
 *		mapping ġ EOF
 *		
 *		 athenaInfo  NULL
 *		
 *		 parent_ptr  NULL
 *		
 *		 child_ptr NULL
 *		
 *		prev_ptr NULL
 *		
 *		next_ptr NULL
 *		
 *		
 ***************************************************************************/
PartsTree *PartsAlloc(void)
{
	PartsTree *alloc_ptr;
	
	alloc_ptr = (PartsTree*)XtMalloc(sizeof(PartsTree));
	if(alloc_ptr != NULL) {
		alloc_ptr->widgetName   = NULL;
		alloc_ptr->variableName = NULL;
		alloc_ptr->className    = NULL;
		alloc_ptr->partsWidget  = NULL;
		alloc_ptr->treeWidget   = NULL;
		alloc_ptr->mapping      = EOF;
		alloc_ptr->athenaInfo   = NULL;
		alloc_ptr->parent_ptr   = NULL;
		alloc_ptr->child_ptr    = NULL;
		alloc_ptr->prev_ptr     = NULL;
		alloc_ptr->next_ptr     = NULL;
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	PartsFree: ʴѤΥޤ
 *	
 *		void PartsFree(PartsTree *release_ptr);
 *	
 *		PartsTree *release_ptr;		ʴ
 *	֤
 *		NULL:		顼ʥ­
 *		NULLʳ:	Ƥ줿
 *	
 *		βӡĥ꡼Խѥȡƥȼ¸ѤΥ
 *		åȤ˴Ԥ
 *		
 *		˴ʬϰʲ̤ꡡ
 *		˴ꨭ
 *		
 *		
 *		å̾ʸ󨭢
 *		
 *		 widgetName 
 *		åȤѿ̾ʸ󨭢
 *		variableName
 *		
 *		  className 饹̾ʥ饹ݥ̾ˡʸ
 *		
 *		 partsWidget
 *		ƥȼ¸ѤΥåȨ
 *		 treeWidget 
 *		
 *		mapping ĥ꡼ɽѤΥåȨ
 *		
 *		 athenaInfo 
 *		
 *		 parent_ptr ˴륦Ȩ
 *		
 *		 child_ptr
 *		
 *		prev_ptr
 *		
 *		next_ptr
 *		
 *		
 ***************************************************************************/
void PartsFree(PartsTree *release_ptr)
{
	if(release_ptr != NULL) {
		if(release_ptr->partsWidget != NULL) {
			XtDestroyWidget(release_ptr->partsWidget);
		}
		if(release_ptr->treeWidget != NULL) {
			XtDestroyWidget(release_ptr->treeWidget);
		}
		if(release_ptr->widgetName != NULL) {
			XtFree(release_ptr->widgetName);
		}
		if(release_ptr->variableName != NULL) {
			XtFree(release_ptr->variableName);
		}
		if(release_ptr->className != NULL) {
			XtFree(release_ptr->className);
		}
		XtFree((char*)release_ptr);
	}
}

/***************************************************************************
 *	partsUnlinkĥ꡼ʤʥ󥯡ˤ
 *	
 *		PartsTree *partsUnlink(PartsTree *parts);
 *	
 *		PartsTree *parts;		󥯤
 *	֤
 *		NULLʳ	󥯤
 *	
 *		  Ƥ¸ߤ뤬¸ߤʤ
 *		
 *		ƤҤؤΥ
 *		
 *		ʨʨ
 *		
 *		ҤƤؤΥ
 *		
 *		ƤҤؤΥ󥯤ڤΥ
 *		 NULL
 *		ʨ
 *		ʨ
 *		
 *		ҤƤؤΥ
 *		
 *		  ʳʤࡢɤʤäƤ뤫˺줿
 *		
 *		ʡ
 *		
 *		
 *		ƤҤء
 *		 NULL
 *		ʨʨ
 *		
 *		ҤƤء
 *		
 *		
 *		ʡ
 *		
 *		
 *		
 *	Х
 *		ʤȻҶʤξƱ¸ߤϡ󥯤
 *		ޤ
 *		Ūˤϡ¹˳Ƥ
 *		
 ***************************************************************************/
PartsTree *partsUnlink(PartsTree *parts)
{
	if(parts != NULL) {
		if(parts->parent_ptr != NULL && 
					parts->prev_ptr == NULL && parts->next_ptr == NULL) {
			/*****************************************
			 *	Ƥ¸ߤ뤬¸ߤʤ
			 *****************************************/
			parts->parent_ptr->child_ptr = parts->child_ptr;
		} else {
			if(parts->child_ptr == NULL) {
				if(parts->prev_ptr != NULL) {
					parts->prev_ptr->next_ptr = NULL;
				}
				if(parts->next_ptr != NULL) {
					parts->next_ptr->prev_ptr = NULL;
				}
			} else {
				fprintf(stderr, "%s:%d:partsUnlink() error. "
					"Can't Unlink!! / "
					"This parts has child & brother(s).\n", 
					__FILE__, __LINE__);
				abort();
			}
		}
		parts->parent_ptr = NULL;
	}
	return(parts);
}

/***************************************************************************
 *	partsUnlinkAndFreeĥ꡼ʤʥ󥯡ˡ
 *	
 *		void partsUnlinkAndFree(PartsTree *parts);
 *	
 *		PartsTree *parts;	󥯡
 *	
 *		
 *	Х
 *		ʤȻҶʤξƱ¸ߤϡ󥯤
 *		ޤ
 *		Ūˤϡ¹˳Ƥ
 *		
 ***************************************************************************/
void partsUnlinkAndFree(PartsTree *parts)
{
	PartsFree(partsUnlink(parts));
}

/***************************************************************************
 *	PartsTopTraceGUIѡĤΥĥ꡼¤ȥ졼
 *	
 *		void PartsTopTrace(PartsTree *parts, 
 *									void (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;						ʴ
 *		void (*PartsProc)(PartsTree *parts);
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 *	ȥ졼˻Ѥʤݥ
 *		
 *		ʤοޤǡߤ֤Ƥݥ󥿤ϻѤƤޤ
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		ߡߡߨߡߡߨ
 *		ߡߡߡߡ
 *		ߡߡߡߡ
 *		ߡߡ
 *		ߡʡʣ˨ߡʡʣ˨
 *		ߡߨߡߨ
 *		ߡߡ
 *		ߡߡ
 *		ߡ
 *		ߡʡʣ˨ʡʣ˨
 *		ߡߨߡߡߨ
 *		ߡߡ
 *		ߡߡ
 *		ߡ
 *		ߡʡʣ˨
 *		ߡߨ
 *		
 *		ϡ¾Υȥ졼äɽƤʤΤƱǤ
 *		
 ***************************************************************************/
void PartsTopTrace(PartsTree *parts, void (*PartsProc)(PartsTree *parts))
{
	if(parts != NULL) {
		if(PartsProc != NULL) {
			PartsProc(parts);
		}
		if(parts->child_ptr != NULL) {
			PartsTopTrace(parts->child_ptr, PartsProc);
		}
		if(parts->next_ptr != NULL) {
			PartsTopTrace(parts->next_ptr, PartsProc);
		}
	}
}

/***************************************************************************
 *	PartsBottomTrace: GUIѡĤΥĥ꡼¤ȥ졼Ԥ
 *	
 *		void PartsBottomTrace(PartsTree *parts, 
 *									void (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;						ʴ
 *		void (*PartsProc)(PartsTree *parts);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 *		
 *	Х
 *		ʤȻҶʤξƱ¸ߤϡ󥯤
 *		ޤ
 *		Ūˤϡ¹˳Ƥ
 *		
 ***************************************************************************/
void PartsBottomTrace(PartsTree *parts, void (*PartsProc)(PartsTree *parts))
{
	if(parts != NULL) {
		if(parts->child_ptr != NULL) {
			PartsBottomTrace(parts->child_ptr, PartsProc);
		}
		if(parts->next_ptr != NULL) {
			PartsBottomTrace(parts->next_ptr, PartsProc);
		}
		if(PartsProc != NULL) {
			PartsProc(parts);
		}
	}
}

/***************************************************************************
 *	PartsSum: GUIѡĤΥĥ꡼¤ȥ졼餫ιͤ
 *	
 *		int PartsSum(PartsTree *parts, int (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;		ʴ
 *		int (*PartsProc)(PartsTree *parts);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		ߤϡѤƤʤ
 *		
 ***************************************************************************/
int PartsSum(PartsTree *parts, int (*PartsProc)(PartsTree *parts))
{
	int sum = 0;

	if(PartsProc != NULL) {
		sum += PartsProc(parts);
	}
	if(parts->child_ptr != NULL) {
		sum += PartsSum(parts->child_ptr, PartsProc);
	}
	if(parts->next_ptr != NULL) {
		sum += PartsSum(parts->next_ptr, PartsProc);
	}
	return(sum);
}

/***************************************************************************
 *	PartsSearch: GUIѡĤΥĥ꡼¤ȥ졼
 *	
 *		XtPointer PartsSearch(PartsTree *parts, 
 *								XtPointer (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;							ʴ
 *		XtPointer (*PartsProc)(PartsTree *parts);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		긡
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 ***************************************************************************/
XtPointer PartsSearch(PartsTree *parts, XtPointer (*PartsProc)(PartsTree *parts))
{
	XtPointer target = NULL;

	if(PartsProc != NULL) {
		target = PartsProc(parts);
	}
	if(parts->child_ptr != NULL && target == NULL) {
		target = PartsSearch(parts->child_ptr, PartsProc);
	}
	if(parts->next_ptr != NULL && target == NULL) {
		target = PartsSearch(parts->next_ptr, PartsProc);
	}
	return(target);
}

/***************************************************************************
 *	PartsTopTrace2: GUIѡĤΥĥ꡼¤ȥ졼
 *	
 *		void PartsTopTrace2(PartsTree *parts, XtPointer client_data, 
 *				void (*PartsProc)(PartsTree *parts, XtPointer client_data));
 *	
 *		PartsTree *parts;			ʴ
 *		XtPointer client_data;
 *		void (*PartsProc)(PartsTree *parts, XtPointer client_data);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 ***************************************************************************/
void PartsTopTrace2(PartsTree *parts, XtPointer client_data, 
				void (*PartsProc)(PartsTree *parts, XtPointer client_data))
{
	if(PartsProc != NULL) {
		PartsProc(parts, client_data);
	}
	if(parts->child_ptr != NULL) {
		PartsTopTrace2(parts->child_ptr, client_data, PartsProc);
	}
	if(parts->next_ptr != NULL) {
		PartsTopTrace2(parts->next_ptr, client_data, PartsProc);
	}
}

/***************************************************************************
 *	PartsTopDownTrace: GUIѡĤΥĥ꡼¤ȥ졼
 *	
 *		void PartsTopDownTrace(PartsTree *parts, Boolean (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;						ʴ
 *		Boolean (*PartsProc)(PartsTree *parts);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 ***************************************************************************/
void PartsTopDownTrace(PartsTree *parts, Boolean (*PartsProc)(PartsTree *parts))
{
	Boolean realizedFlag = True;

	if(parts != NULL) {
		if(PartsProc != NULL) {
			realizedFlag = PartsProc(parts);
		}
		if(realizedFlag == FALSE && parts->child_ptr != NULL) {
			PartsTopDownTrace(parts->child_ptr, PartsProc);
		}
		if(parts->next_ptr != NULL) {
			PartsTopDownTrace(parts->next_ptr, PartsProc);
		}
	}
}

#ifdef	TEST_IMPREMENT
/***************************************************************************
 *	TestNearlyPartsLink: 
 *	
 *		static int TestNearlyPartsLink(PartsTree *parts);
 *	
 *		PartsTree *parts;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
static int TestNearlyPartsLink(PartsTree *parts)
{
	int linkIsMissing = FALSE;

	if(parts == NULL) {
		return(EOF);
	}
	if(parts->prev_ptr != NULL) {
		/* ȿƤȤΥ󥯤ʰ׳ǧ */
		linkIsMissing |= parts->prev_ptr->next_ptr != parts;
		linkIsMissing |= parts->prev_ptr->parent_ptr != parts->parent_ptr;
	} else {
		/* ƤȤΥ󥯤ǧ */
		linkIsMissing |= (parts->parent_ptr != NULL && 
								parts->parent_ptr->chile_ptr != parts);
	}
}

/***************************************************************************
 *	PartsTraceSameParents: GUIѡĤΥĥ꡼¤ȥ졼
 *	
 *		void PartsTopTrace2(PartsTree *parts, XtPointer client_data, 
 *				void (*PartsProc)(PartsTree *parts, XtPointer client_data));
 *	
 *		PartsTree *parts;			ʴ
 *		XtPointer client_data;
 *		void (*PartsProc)(PartsTree *parts, XtPointer client_data);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 ***************************************************************************/
int PartsTraceSameParents(PartsTree *parts, XtPointer client_data, 
				void (*PartsProc)(PartsTree *parts, XtPointer client_data))
{
	int finished = FALSE;

	if(PartsProc != NULL) {
		finished = PartsProc(parts, client_data);
	}
	if(!finished && parts->child_ptr != NULL) {
		finished = PartsTraceSameParents(parts->child_ptr, client_data, PartsProc);
	}
	if(!finished && parts->next_ptr != NULL) {
		finished = PartsTraceSameParents(parts->next_ptr, client_data, PartsProc);
	}
	return(finished);
}
#endif	/*TEST_IMPREMENT*/

/***************************************************************************
 *	isParts: ƥʤꥢ饤Ƥ뤫ɤȽꤹؿ
 *	
 *		int isParts(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʴ
 *	֤
 *		FALSE:		¸Ƥʤ
 *		TRUE:		¸Ƥ
 *	
 *		
 ***************************************************************************/
int isParts(PartsTree *parts)
{
	return((parts != NULL)?(parts->partsWidget != NULL):(FALSE));
}

/***************************************************************************
 *	whereIsPartsWidget: ʤƥʤΥåȤ֤ؿ
 *	
 *		XtPointer whereIsPartsWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʴ
 *	֤
 *		NUUL:		ƥʤǤʤä̤
 *		NULLʳ:	ƥʤΥåȤؤݥ
 *	
 *		
 ***************************************************************************/
XtPointer whereIsPartsWidget(PartsTree *parts)

{
	return((XtPointer)(parts != NULL)?(parts->partsWidget):(NULL));
}

/***************************************************************************
 *	whereIsTreeWidget: ʤĥ꡼ʤΥåȤ֤ؿ
 *	
 *		XtPointer whereIsTreeWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʴ
 *	֤
 *		NUUL:		ĥ꡼¤ɽѥȤǤʤä
 *		NULLʳ:	ĥ꡼¤ɽѥȤؤݥ
 *	
 *		
 ***************************************************************************/
XtPointer whereIsTreeWidget(PartsTree *parts)
{
	return((XtPointer)(parts != NULL)?(parts->treeWidget):(NULL));
}

/***************************************************************************
 *	youngestBrother: ƱΡɤθǺǸ˺줿ʤõ
 *	
 *		PartsTree *youngestBrother(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
PartsTree *youngestBrother(PartsTree *parts)
{
	if(parts != NULL) {
		while(parts->next_ptr != NULL)
			parts = parts->next_ptr;
	}
	return(parts);
}

/***************************************************************************
 *	connectToTailƱΡɤθǺǸʤؤ󥯥ݥ󥿤õ
 *	
 *		PartsTree **connectToTail(PartsTree **parts);
 *	
 *		PartsTree *parts;		ʴ
 *	֤
 *		
 *	
 *		ƱΡɤθǺǸʤؤ󥯥ݥ󥿤Υɥ쥹֤
 *		̤ѡ
 *		
 ***************************************************************************/
PartsTree **connectToTail(PartsTree **parts)
{
	if(*parts != NULL) {
		while((*parts)->next_ptr != NULL)
			parts = &(*parts)->next_ptr;
	}
	return(parts);
}

/***************************************************************************
 *	partsPointer: 򤵤ƤʤΡɤˤ
 *	
 *		void partsPointer(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				ĥ꡼
 *		XtPointer client_data;	ʼʬȤΡʾ
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		򤵤Ƥ(CurrentParts)ʬȤˤ
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ĥ꡼				------				ľܤΥХåؿ
 *						ʥĥ꡼ʡ		
 *	
 *		
 *		
 ***************************************************************************/
void partsPointer(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = (PartsTree*)client_data;
	PartsTree newParts;

	CurrentParts = parts;
	makableObject(parts);	/* ǽʥåȤΥꥹȤ */
}

/***************************************************************************
 *	partsChildLinkĥ꡼ʤϢʥ󥯡ˤ
 *	
 *		PartsTree *partsChildLink(PartsTree *node, PartsTree *newParts);
 *	
 *		PartsTree *node;		ʤɲä֡ʥΡɡ
 *		PartsTree *newParts;	ʻҶȤơ³
 *	֤
 *		NULL		顼
 *		NULLʳ	ɲä줿ʤΥΡ
 *	
 *		ߤιˤꣲϢʥ󥯡ˡޤ줾
 *		ˡ򼨤ޤ
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤʤ
 *		
 *		
 *		
 *		ʹĥ꡼ΥΡɨʨ
 *		
 *		 widgetName ʸ󨭡 widgetName ʸ
 *		
 *		variableNameʸ󨭡variableNameʸ
 *		
 *		  className ʸ󨭡  className ʸ
 *		
 *		 partsWidget partsWidget
 *		
 *		 treeWidget  treeWidget 
 *		
 *		mapping mapping 
 *		
 *		 athenaInfo ġ athenaInfo 
 *		
 *		 parent_ptr  parent_ptr 
 *		
 *		 child_ptr child_ptr   NULL 
 *		
 *		prev_ptr롡prev_ptr NULL 
 *		  
 *		next_ptrnext_ptr NULL 
 *		
 *		
 *		
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤ
 *		
 *		ʹĥ꡼κܨʺǯĹΡ˻ʨ
 *		
 *		 widgetName ʸ󨭡 widgetName ʸ
 *		
 *		variableNameʸ󨭡
 *		
 *		  className ʸ󨭡 parent_ptr 
 *		
 *		 partsWidget child_ptr  
 *		
 *		 treeWidget prev_ptr NULL 
 *		
 *		mapping next_ptr
 *		
 *		 athenaInfo 
 *		
 *		 parent_ptr  parent_ptr Ǥ
 *		ʺǯ
 *		 child_ptr child_ptr  λʨ 
 *		
 *		prev_ptrprev_ptr NULL 
 *		
 *		next_ptrnext_ptr
 *		
 *		
 *		
 *		ɲäʨ
 *		
 *		 widgetName ʸ
 *		
 *		variableNameʸ
 *		먢
 *		ꨢ className  ʸ
 *		󨢡
 *		 partsWidget
 *		
 *		 treeWidget 
 *		
 *		mapping 
 *		
 *		 athenaInfo 
 *		
 *		 parent_ptr 
 *		
 *		먢 child_ptr   NULL 
 *		󥯨
 *		prev_ptr
 *		
 *		먭next_ptr NULL 
 *		󥯨
 *		
 *		
 *		
 ***************************************************************************/
PartsTree *partsChildLink(PartsTree *node, PartsTree *newParts)
{
	if(node != NULL && newParts != NULL) {
		if(node->child_ptr == NULL) {
			/*********************************************************
			 *	ʤɲäΡɤ˻ҥåȤ¸ߤʤ
			 *********************************************************/
			node->child_ptr = newParts;
			newParts->parent_ptr = node;
		} else {
			/*******************************************************
			 *	ʤɲäΡɤ˻ҥåȤ¸ߤ
			 *******************************************************/
			newParts->parent_ptr = node;
			newParts->prev_ptr = youngestBrother(node->child_ptr);
			newParts->prev_ptr->next_ptr = newParts;
		}
	}
	return(node);
}

/***************************************************************************
 *	rootPartsĥ꡼κܤ֤
 *	
 *		PartsTree *rootParts(PartsTree *node);
 *	
 *		PartsTree *node;		
 *	֤
 *		NULL		顼
 *	
 *		ʹĥ꡼ǿƤؤݥ󥿤Ȥäƥĥ꡼¤κܤõޤ
 *		
 *		ߢߢ
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		ߡ
 *		
 *		
 *		ʡʣ˨
 *		
 *	
 ***************************************************************************/
PartsTree *rootParts(PartsTree *parts)
{
	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;
	return(parts);
}

/***************************************************************************
 *	partsAppendĥ꡼ʤɲä
 *	
 *		PartsTree *partsAppend(PartsTree *node, 
 *							const char *widgetName, AWidgetInfo *awInfo);
 *	
 *		PartsTree *node;		ʤɲä֡ʥΡɡ
 *		char *widgetName;		ɲäʤΥå̾
 *		AWidgetInfo *awInfo;	ɲäʤξ
 *	֤
 *		NULL		­or顼
 *		NULLʳ	ɲäʤΥΡ
 *	
 *		ʲνԤޤ
 *		
 *		  ʤʽ줿
 *		  å̾˥Ƥ̾򥳥ԡ
 *		  ʼ
 *		  ĥ꡼ѤΥåȤκʥ٥դ
 *		  ĥ꡼ѤΥåȤΥ饸롼פؤɲ
 *		  ĥ꡼ѤΥåȤʰּؿΥХåϿ
 *		  ĥ꡼ѤΥåȤμ¸
 *		
 *		ʬϰʲ̤
 *		
 *		Ƥꨭ
 *		
 *		
 *		֤͡ϡ
 *		
 *		
 *		 widgetName å̾ʸ
 *		
 *		variableName NULL: åȤѿ̾ʸ
 *		
 *		  className  NULL: 饹̾ʸ
 *		
 *		 partsWidget NULL: ƥȼ¸ѤΥå
 *		
 *		 treeWidget ĥ꡼ɽѤΥåȨ
 *		
 *		mapping ġ EOF
 *		
 *		 athenaInfo ¸μؤ
 *		
 *		 parent_ptr  NULL 
 *		륦åȨ
 *		 child_ptr NULL 
 *		
 *		prev_ptr NULL
 *		
 *		next_ptr NULL
 *		
 *		
 ***************************************************************************/
PartsTree *partsAppend(PartsTree *node, 
								const char *widgetName, AWidgetInfo *awInfo)
{
	PartsTree *newParts;
	extern Widget mguiTree;

	newParts = PartsAlloc();	/* ʤο */
	if(newParts != NULL) {
		newParts->widgetName = XtNewString(widgetName);	/* å̾ */
		newParts->athenaInfo = awInfo;				/* ʼ */
		newParts->treeWidget = 
				XtVaCreateManagedWidget(
						widgetName, 
						toggleWidgetClass, 
						mguiTree, 
						XtNtreeParent, 
								((node != NULL)?(node->treeWidget):(NULL)), 
						/* XtNlabel, newParts->widgetName, */
						XtNlabel, defaultLabel(newParts),
						XtNradioData, newParts,
						NULL);
		if(node != NULL) {
			/* 饸롼פ礹 */
			XawToggleChangeRadioGroup(newParts->treeWidget, node->treeWidget);
		}
		XtAddCallback(newParts->treeWidget, 
						XtNcallback, partsPointer, (XtPointer)newParts);
		XtRealizeWidget(newParts->treeWidget);	/* ĥ꡼¤ʤμ¸ */
	}
	return(newParts);
}

/***************************************************************************
 *	partsAddʤɲä
 *	
 *		void partsAdd(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	ʾ
 *		XtPointer call_data;	̤
 *	
 *		
 *		
 *		ʬϰʲ̤
 *		
 *		Ƥꨭ
 *		
 *		
 *		
 *		
 *		
 *		 widgetName å̾
 *		
 *		variableName NULL: åȤѿ̾ʸ
 *		
 *		  className  NULL orץꥱ󥯥饹̾
 *		
 *		 partsWidget NULL: ƥȼ¸ѤΥå
 *		
 *		 treeWidget ĥ꡼ɽѤΥåȨ
 *		
 *		mapping ġ EOF
 *		
 *		 athenaInfo ¸μؤ
 *		
 *		 parent_ptr  NULL or Ƥإ 
 *		륦åȨ
 *		 child_ptr NULL 
 *		
 *		prev_ptr NULL or ˤʡ¸ߤ
 *		
 *		next_ptr NULL
 *		
 *	Ȼ
 *		partsChildLink();ġġ󥯤ĥˤĤƤξ
 *		currentWidgetNameġġߤΥå̾ʥ롼Хѿ
 *		
 ***************************************************************************/
void partsAdd(Widget w, XtPointer client_data, XtPointer call_data)
{
	char className[256];	/* ץꥱ󥳥ƥѥ饹̾Хåե */
	PartsTree **parts = (PartsTree**)client_data;
	PartsTree *newParts;
	XawListReturnStruct *awTarget;

	/* List 򤵤줿ʼ */
	awTarget = XawListShowCurrent(mguiList);

	if(parts != NULL && awTarget->list_index != XAW_LIST_NONE) {
		/***************************************************************
		 *	ʤɲð֤ꤷ餫ʤμब򤵤Ƥ
		 ***************************************************************/
		newParts = partsAppend(*parts, currentWidgetName, 
							*(awidgetInfo + awTarget->list_index));
		if(*parts == NULL) {
			/*********************************************************
			 *	ǽʡʥץꥱ󥳥ƥȡ˺Τ
			 *********************************************************/
			sprintf(className, "%c%s", toupper(*currentWidgetName), 
					currentWidgetName+(*currentWidgetName != '\0'));
			newParts->className = XtNewString(className);
			*parts = newParts;
		} else {
			/*************************************************************
			 *	̤ʡʥץꥱ󥳥ƥȰʳ˺Τ
			 *************************************************************/
			(void)partsChildLink(*parts, newParts);
		}
		variableNaming(newParts, currentWidgetName);
		partsRenewal(*parts);
	}
}

/***************************************************************************
 *	partsDeleteOne: ꤵ줿ʤ
 *	
 *		void partsDeleteOne(PartsTree *parts);
 *	
 *		PartsTree *parts;	ʴ
 *	֤
 *		
 *	
 *		ߤιˤꣲϢʥ󥯡ˡޤ줾
 *		ˡ򼨤ޤ
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤʤ
 *		
 *		
 *		
 *		ʹĥ꡼ΥΡɨʨ
 *		̵ˤʨ
 *		 widgetName ʸ󨭡󥯡
 *		
 *		variableNameʸ󨭡 parent_ptr 
 *		
 *		  className ʸ󨭡 child_ptr   NULL 
 *		
 *		 partsWidgetprev_ptr NULL 
 *		
 *		 treeWidget next_ptr
 *		
 *		mapping 
 *		郎ʤ NULL
 *		 athenaInfo ġ
 *		ʡ
 *		 parent_ptr 
 *		
 *		 child_ptr
 *		 parent_ptr 
 *		prev_ptrѡ
 *		 child_ptr  
 *		next_ptr
 *		prev_ptr
 *		
 *		next_ptr
 *		롡郎
 *		ꡡ
 *		󡡡
 *		
 *		
 *			ڢۡѹ
 *			ڢ̵ۡˤʤ󥯡˻Ѥޤ
 *		
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤ
 *		
 *		ʹĥ꡼κܨʨ
 *		
 *		 widgetName ʸ󨭡
 *		
 *		variableNameʸ󨭡 parent_ptr 
 *		
 *		  className ʸ󨭡 child_ptr  
 *		
 *		 partsWidgetprev_ptrNULL
 *		
 *		 treeWidget next_ptr
 *		
 *		mapping 
 *		ʨ
 *		 athenaInfo 
 *		
 *		 parent_ptr 
 *		 parent_ptr 
 *		 child_ptr
 *		 child_ptr  
 *		prev_ptr
 *		prev_ptr
 *		next_ptr
 *		next_ptr
 *		
 *		
 *		ʡ
 *		
 *		
 *		
 *		 parent_ptr 
 *		
 *		 child_ptr  
 *		
 *		prev_ptr
 *		
 *		next_ptr
 *		Ѥ
 *		
 *		
 *		
 *			ڢۡѹΥ
 *			ڢۡѹΥ󥯡ʹ줿󥯡
 *			ڢ̵ۡˤʤ󥯡˻Ѥޤ
 *	Х
 *		1997/12/17 ʳޤǤǤϡ󥯤κˡ꤬롣
 *		1997/12/18 νˤƤνϴǤϤʤ
 *		ϡʤ¸ߤΤθƤʤˤ롣
 *		
 ***************************************************************************/
void partsDeleteOne(PartsTree *parts)
{
	if(parts != NULL) {
		if(parts->prev_ptr == NULL) {
			/***********************
			 *	ʤ¸ߤʤ
			 ***********************/
			if(parts->parent_ptr != NULL) {
				/* ϡƤΥ󥯤ǤΤ */
				if(parts->next_ptr != NULL) {
					parts->parent_ptr->child_ptr = parts->next_ptr;	/* ɲ */
					parts->next_ptr->prev_ptr = NULL;	/* ɲ */
				} else {
					parts->parent_ptr->child_ptr = NULL;
				}
			}
		} else {
			/*********************
			 *	ʤ¸ߤ
			 *********************/
			parts->prev_ptr->next_ptr = parts->next_ptr;
			if(parts->next_ptr != NULL) {
				parts->next_ptr->prev_ptr = parts->prev_ptr;
			}
		}
		XtDestroyWidget(parts->treeWidget);
		XtFree((char*)parts);
	}
}

/***************************************************************************
 *	partsDeleteʤ
 *	
 *		void partsDelete(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				mguiDel/cmdMenuInfo.myWidget[2] å
 *		XtPointer client_data;	ʾ
 *		XtPointer call_data;	̤
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ġ				mguiDel			ľܤΥХå
 *	
 *		˥塼	cmdMenuInfo[2].myWidget	partsDeleteInMenu 
 *	
 *		
 *		ʲΤ褦ˡ¦ȥ졼ʤʲνʤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 *		
 *	Ȼ
 *		partsDeleteOne() -- ꤵ줿ʤؿ
 *		
 ***************************************************************************/
void partsDelete(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree **parts = (PartsTree**)client_data;
	PartsTree *newParts;
	Widget parentTree;
	extern Widget mguiTree;

	if(parts != NULL) {
		if(*parts != NULL) {
			PartsBottomTrace((*parts)->child_ptr, partsDeleteOne);
			partsDeleteOne(*parts);
			*parts == NULL;
		}
	}
}

/***************************************************************************
 *	partsDeleteInMenu˥塼ʤޤ
 *	
 *		void partsDeleteInMenu(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 *		
 *	Ȼ
 *		partsDeleteOne() --	ꤵ줿ʤؿ
 *		partsDelete() -- 	ʤ
 *		
 ***************************************************************************/
void partsDeleteInMenu(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	partsDelete(w, parts, call_data);
}

/***************************************************************************
 *	PopupNamingDialog: ͡ѤΥϿѤΥΥݥåץå
 *	
 *		void PopupNamingDialog(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	dialog åȡ̾ʡ
 *		XtPointer call_data;	̤
 *	
 *		
 *		ʲΥåȤΥХåؿǤ
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ġ				mguiAdd				ľܤΥХåؿ
 *	
 *		˥塼	cmdMenuInfo[1].myWidget 	ľܤΥХåؿ
 *							(cmdAdd)			
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopupNamingDialog(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget enterShell;
	Position x, y;
	Dimension width, height;
	
	enterShell = XtParent((Widget)client_data);
	/***********************************
	 *	Root Window κɸϤѴ
	 ***********************************/
	XtTranslateCoords(XtParent(enterShell),		/* Widget */
						(Position) 0,			/* x */
						(Position) 0,			/* y */
						&x, &y);				/* coords on root window */

	/*******************************************************************
	 *	ݥåץåץΰ֤ꤹʤޤвƤʤ
	 *******************************************************************/
	XtVaSetValues(enterShell, XtNx, x, XtNy, y, NULL);

	XtPopup(enterShell, XtGrabExclusive);
}

/***************************************************************************
 *	NamingDialogSet: 
 *	
 *		void NamingDialogSet(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void NamingDialogSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget dialog = (Widget)client_data;

	/*****************************************************
	 *	åȤϤʸ
	 *****************************************************/
	currentWidgetName = XawDialogGetValueString(dialog);
	XtPopdown(XtParent(client_data));
	partsAdd(w, &CurrentParts, NULL);
}

/***************************************************************************
 *	NamingDialogPopdown: å̾̿̾ѤΥɥݥåץ
 *	
 *		void NamingDialogPopdown(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void NamingDialogPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popdownWidget = (Widget)client_data;

	XtPopdown(XtParent(popdownWidget));
}

/***************************************************************************
 *	PopdownAncestorShell: åȤκǤᤤĤΥݥåץ
 *	
 *		void PopdownAncestorShell(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				ݥåץ׵ᤷå
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		ѤΥХåؿåȤκǤᤤĤΥݥå
 *		󤷤ޤ
 *		
 *	
 *		ʤξ		å̾			
 *	
 *			mguiPopdown			ľܤΥХå
 *			ġ							mguiSourceShell ݥå
 *												
 *	
 *		꥽	mguiResFilePopdown		ľܤΥХå
 *			ġ							mguiResourceFileShell 
 *												ݥåץ
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopdownAncestorShell(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popdownWidget = w;

	while(popdownWidget != NULL && XtIsShell(popdownWidget) == False) {
		popdownWidget = XtParent(popdownWidget);
	}

	XtPopdown(popdownWidget);
}

/***************************************************************************
 *	hasParent: ƥåȤ¸ߤĴ٤
 *	
 *		Boolean hasParent(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		:		ƥåȤ¸
 *		:		ƥåȤ¸ߤʤ
 *	
 *		
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasParent(AWidgetInfo *myWidget, PartsTree *parts)
{
	Boolean result = FALSE;

#ifdef	DEBUG
	printf("hasParent<");
#endif	/*DEBUG*/
	if(parts != NULL) {
		result = (parts->parent_ptr != NULL);
#ifdef	OLD_IMPREMENT
		result = ((parts->parent_ptr != NULL)?
						(parts->parent_ptr->partsWidget != NULL):(False));
#endif	/*OLD_IMPREMENT*/
#ifdef	DEBUG
		printf("(%s)", parts->widgetName);	fflush(stdout);
#endif	/*DEBUG*/
	}
#ifdef	DEBUG
	printf("=%d>", result);	fflush(stdout);
#endif	/*DEBUG*/
	return(result);
}

/***************************************************************************
 *	hasChild: ҥåȤ¸ߤĴ٤
 *	
 *		Boolean hasChild(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		:		ҥåȤ¸
 *		:		ҥåȤ¸ߤʤ
 *	
 *		ƹǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasChild(AWidgetInfo *myWidget, PartsTree *parts)
{
	Boolean result = FALSE;

#ifdef	DEBUG
	printf("hasChild<");
#endif	/*DEBUG*/
	if(parts != NULL) {
		if((parts->child_ptr != NULL)?
				(parts->child_ptr->athenaInfo != NULL):(False)) {
			result = parts->child_ptr->athenaInfo->remakable(
										parts->child_ptr->athenaInfo, 
														parts->child_ptr);
		}
#ifdef	DEBUG
		printf("(%s)", parts->widgetName);	fflush(stdout);
#endif	/*DEBUG*/
	}
#ifdef	DEBUG
	printf("=%d>", result);	fflush(stdout);
#endif	/*DEBUG*/
	return(result);
}

/***************************************************************************
 *	hasFamily: ơҥåȤ¸ߤĴ٤
 *	
 *		Boolean hasFamily(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		:		ơҥåȤ¸
 *		:		ơҥåȤ¸ߤʤ
 *	
 *		ƹǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasFamily(AWidgetInfo *myWidget, PartsTree *parts)
{
	Boolean result = FALSE;

#ifdef	DEBUG
	printf("hasFamily<");
#endif	/*DEBUG*/
	if(parts != NULL) {
		result = (parts->parent_ptr != NULL) &&
				((parts->child_ptr != NULL && parts->child_ptr->athenaInfo != NULL)?
					(parts->child_ptr->athenaInfo->remakable(
							parts->child_ptr->athenaInfo, parts->child_ptr)):(False));
#ifdef	DEBUG
		printf("(%s)", parts->widgetName);	fflush(stdout);
#endif	/*DEBUG*/
	}
#ifdef	DEBUG
	printf("=%d>", result);	fflush(stdout);
#endif	/*DEBUG*/
	return(result);
}

/***************************************************************************
 *	hasNoFamily: ơҥåȤ¸ߤĴ٤
 *	
 *		Boolean hasNoFamily(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		:		ơҥåȤ¸ߤʤ
 *		:		ơҥåȤ¸
 *	
 *		ĥ꡼¤ǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasNoFamily(AWidgetInfo *myWidget, PartsTree *parts)
{
	return(parts == NULL);
}

/***************************************************************************
 *	hasNormalChild: ̤λҥåȤ¸ߤĴ٤
 *	
 *		Boolean hasNormalChild(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		:		ҥåȤ¸
 *		:		ҥåȤ¸ߤʤ
 *	
 *		åȼ¸ǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasNormalChild(AWidgetInfo *myWidget, PartsTree *parts)
{
	Boolean result = FALSE;
	PartsTree *parts_ptr;

	if(parts != NULL) {
		for(parts_ptr = parts->child_ptr;
					parts_ptr != NULL;parts_ptr = parts_ptr->next_ptr) {
			if(parts_ptr->athenaInfo != NULL) {
				result = 
					result || (parts_ptr->athenaInfo->type & NormalWidget);
			}
		}
	}
	return(result);
}

/***************************************************************************
 *	partsExist: 򤵤ƤѡĤ¸ߤĴ٤
 *	
 *		Boolean partsExist(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		:		򤵤Ƥ륦åȤ¸
 *		:		򤵤Ƥ륦åȤ¸ߤʤ
 *	
 *		ĥ꡼¤ǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean partsExist(AWidgetInfo *myWidget, PartsTree *parts)
{
	return(parts != NULL);
}

/***************************************************************************
 *	alwaysMakable: ˥åȺǽʤȤ֤ؿ
 *	
 *		Boolean alwaysMakable(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		˿		ʥåȺǽ
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean alwaysMakable(AWidgetInfo *myWidget, PartsTree *parts)
{
	return(True);
}

/***************************************************************************
 *	alwaysDismakable: ˥åȺԲǽʤȤ֤ؿ
 *	
 *		Boolean alwaysDismakable(struct _AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		˵		ʥåȺԲǽ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean alwaysDismakable(AWidgetInfo *myWidget, PartsTree *parts)
{
	return(False);
}

/***************************************************************************
 *	widgetCreater: ̤ΥåȤ
 *	
 *		void widgetCreater(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;
 *		PartsTree *parts;		ʴ
 *	֤
 *		
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
void widgetCreater(AWidgetInfo *myWidget, PartsTree *parts)
{
	if(parts != NULL) {
		if(parts->parent_ptr == NULL) {
			printf("No parent!!\n");
#ifdef	DEBUG
		} else {
			printf("%s:%d:%s's parent is \"%s-", __FILE__, __LINE__, 
					parts->widgetName, parts->parent_ptr->widgetName);
			fflush(stdout);
			printf("-%s\".\n", 
				((parts->parent_ptr->partsWidget != NULL)?
					(XtName(parts->parent_ptr->partsWidget)):("<<NULL>>")));
#endif	/*DEBUG*/
		}
#ifdef	DEBUG
		printf("%s:%d:XtVaCreateManagedWidget(\"%s\"); : -> Create", 
					__FILE__, __LINE__, parts->widgetName);
		fflush(stdout);
#endif	/*DEBUG*/
/************************************************************************************************************************/
		if(parts->parent_ptr != NULL && parts->parent_ptr->partsWidget != NULL) {
			parts->partsWidget = 
				XtVaCreateManagedWidget(
						parts->widgetName, 
						*myWidget->partsClass, 
						((parts->parent_ptr != NULL)?	\
							(parts->parent_ptr->partsWidget):(NULL)), NULL);
	#ifdef	DEBUG
			printf("\"%s\"\n", XtName(parts->partsWidget));
			fflush(stdout);
	#endif	/*DEBUG*/
	#ifdef	OLD
			switch(parts->mapping) {
			case True:
				XtMapWidget(parts->partsWidget);
				break;
			case False:
				XtUnmapWidget(parts->partsWidget);
				break;
			case EOF:
				break;
			}
#endif	/*OLD*/
		}
#ifdef	DEBUG
	} else {
		printf("%s:%d:%s's class is \"%s\" << pass >>\n", __FILE__, __LINE__, 
				parts->widgetName, parts->athenaInfo->className);
#endif	/*DEBUG*/
	}
}

/***************************************************************************
 *	shellCreater: Shell åȤ
 *	
 *		void shellCreater(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void shellCreater(AWidgetInfo *myWidget, PartsTree *parts)
{
	if(parts != NULL) {
#ifdef	DEBUG
		printf("%s:%d:XtVaCreatePopupShell(\"%s\"); : -> Create", 
							__FILE__, __LINE__, parts->widgetName);
		fflush(stdout);
#endif	/*DEBUG*/
		if(parts->parent_ptr != NULL) {
			parts->partsWidget = 
				XtVaCreatePopupShell(
						parts->widgetName, 
						*myWidget->partsClass, 
						parts->parent_ptr->partsWidget, 
						NULL);
		} else {
			parts->partsWidget = 
				XtVaCreatePopupShell(
						parts->widgetName, 
						*myWidget->partsClass, 
						topLevel, 
						NULL);
		}
#ifdef	DEBUG
		printf("\"%s\"\n", XtName(parts->partsWidget));
		fflush(stdout);
#endif	/*DEBUG*/
#ifdef	OLD
		switch(parts->mapping) {
		case True:
			XtMapWidget(parts->partsWidget);
			break;
		case False:
			XtUnmapWidget(parts->partsWidget);
			break;
		case EOF:
			break;
		}
#endif	/*OLD*/
#ifdef	DEBUG
	} else {
		printf("%s:%d:%s's class is \"%s\" << pass >>\n", __FILE__, __LINE__, 
				parts->widgetName, parts->athenaInfo->className);
#endif	/*DEBUG*/
	}
}

/***************************************************************************
 *	partsMapping: åȤΥޥåסޥåפꤹ
 *	
 *		void partsMapping(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsMapping(PartsTree *parts)
{
	if(parts != NULL) {
		if((parts->partsWidget != NULL)?
					(XtIsRealized(parts->partsWidget)):(False)) {
			switch(parts->mapping) {
			case True:
#ifdef	DEBUG
				printf("%s:%d:XtMapWidget(\"%s\");\n", 
						__FILE__, __LINE__, XtName(parts->partsWidget));
#endif	/*DEBUG*/
				XtMapWidget(parts->partsWidget);
				break;
			case False:
#ifdef	DEBUG
				printf("%s:%d:XtUnmapWidget(\"%s\");\n", 
						__FILE__, __LINE__, XtName(parts->partsWidget));
#endif	/*DEBUG*/
				XtUnmapWidget(parts->partsWidget);
				break;
			case EOF:
				break;
			}
		}
#ifdef	OLD
	} else {
		printf("%s:%d:%s's class is \"%s\" << pass >>\n", __FILE__, __LINE__, 
				parts->widgetName, parts->athenaInfo->className);
#endif	/*OLD*/
	}
}

/***************************************************************************
 *	makableObject: ǽʥåȤΥꥹȤ
 *	
 *		void makableObject(PartsTree *parts);
 *	
 *		PartsTree *parts;		򤵤Ƥƥå
 *								NULL ʤƾ̤Υåȡ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void makableObject(PartsTree *parts)
{
	int counter, limit, sum;
	static char *empty = "Empty";

	limit = sizeof(widgetSet)/sizeof(widgetSet[0]);
	if(widgetList == NULL) {
		widgetList  = (char**)malloc(sizeof(char*) * limit);
	}
	if(awidgetInfo == NULL) {
		awidgetInfo = (AWidgetInfo**)malloc(sizeof(AWidgetInfo*) * limit);
	}
	for(counter = 0;counter < limit;++counter) {
		*(widgetList  + counter) = NULL;
		*(awidgetInfo + counter) = NULL;
	}
	for(sum = 0, counter = 0;counter < limit;++counter) {
		if(widgetSet[counter].creatable != NULL) {
			if(widgetSet[counter].creatable(&widgetSet[counter], parts)) {
				*(widgetList  + sum) = (char*)widgetSet[counter].className;
				*(awidgetInfo + sum) = &widgetSet[counter];
				++sum;
			}
		}
	}
	if(sum == 0) {
		XawListChange(mguiList, &empty, 1, 0, True);
		XtSetSensitive(mguiList, False);
	} else {
		XawListChange(mguiList, widgetList, sum, 0, True);
		XtSetSensitive(mguiList, True);
	}
}

#ifdef	CREATE_SAMPLE
/***************************************************************************
 *	: 
 *	
 *		void Creation(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;			ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void Creation(PartsTree *currentParts)
{
	parts->treeWidget = 
		XtVaCreateManagedWidget(
				currentWidgetName, 
				, 
				, 
				NULL);
	XtRealizeWidget(parts->treeWidget);
}
#endif	/*CREATE_SAMPLE*/

/***************************************************************************
 *	partsDestroyWidget: ƥȼ¸åȤ˴
 *	
 *		void partsDestroyWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;	ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void partsDestroyWidget(PartsTree *parts)
{
	if(parts != NULL) {
		if(parts->partsWidget != NULL) {
#ifdef	DEBUG
			printf("%s:%d:XtDestroyWidget(\"%s\");\n", 
					__FILE__, __LINE__, XtName(parts->partsWidget));
#endif	/*DEBUG*/
			XtDestroyWidget(parts->partsWidget);
		}
		parts->partsWidget = NULL;
	}
}

/***************************************************************************
 *	partsCreateWidget: 
 *	
 *		void partsCreateWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;	ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void partsCreateWidget(PartsTree *parts)
{
	if((parts != NULL)?(parts->athenaInfo != NULL):(False)) {
#ifdef	DEBUG
		printf("\"%s\"-\"%s\"<<", 
						parts->widgetName, parts->athenaInfo->className);
		fflush(stdout);
#endif	/*DEBUG*/
		if(parts->athenaInfo->remakable != NULL) {
			if(parts->athenaInfo->remakable(parts->athenaInfo, parts)) {
#ifdef	DEBUG
				printf(":we will remake.>>\n");
#endif	/*DEBUG*/
				if(parts->athenaInfo->widgetCreation != NULL) {
					parts->athenaInfo->widgetCreation(
												parts->athenaInfo, parts);
				}
#ifdef	DEBUG
			} else {
				printf(": I can't remake.>>\n");
#endif	/*DEBUG*/
			}
#ifdef	DEBUG
		} else {
			printf("No Way to remake.>>\n");
#endif	/*DEBUG*/
		}
	}
}

/***************************************************************************
 *	partsRealize: 
 *	
 *		Boolean partsRealize(PartsTree *parts);
 *	
 *		PartsTree *parts;	ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
Boolean partsRealize(PartsTree *parts)
{
	Boolean realizableFlag = True;

	if(parts->athenaInfo->realizable != NULL) {
		/*******************************************************
		 *	ƥʤμ¸ǽȽؿƤ
		 *******************************************************/
		realizableFlag = 
				parts->athenaInfo->realizable(parts->athenaInfo, parts);
	}
	if(realizableFlag && parts->partsWidget != NULL) {
		/***********************************************
		 *	
		 ***********************************************/
		XtRealizeWidget(parts->partsWidget);
	}
	return(realizableFlag);
}

/***************************************************************************
 *	partsRenewal: ʤκƹۤԤ
 *	
 *		void partsRenewal(PartsTree *parts);
 *	
 *		PartsTree *parts;	ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void partsRenewal(PartsTree *parts)
{
	int counter, length;
	Boolean autoMapFlag;

	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;

	if(parts != NULL) {
#ifdef	DEBUG
		printf("\n~-_-~   ~-_-~   ~-_-~   ~-_-~   ~-_-~   ~\n");fflush(stdout);
		length = printf("> Widget Tree of \"%s\"\n", parts->widgetName);
		for(counter = 0;counter < length;++counter)
			printf("~");
		printf("\n");
#endif	/*DEBUG*/
		PartsBottomTrace(parts->child_ptr, partsDestroyWidget);	/* ƥʤ˴ */
		partsDestroyWidget(parts);
	
		partsCreateWidget(parts);
		PartsTopTrace(parts->child_ptr, partsCreateWidget);
		if(parts->partsWidget != NULL) {
#ifdef	OLD
			XtVaGetValues(parts->partsWidget, 
					XtNmappedWhenManaged, &autoMapFlag, NULL);
#endif	/*OLD*/
			PartsTopDownTrace(parts, partsRealize);
			PartsBottomTrace(parts, partsMapping);
		}
#ifdef	DEBUG
		printf("_-~-_   _-~-_   _-~-_   _-~-_   _-~-_   _\n\n");fflush(stdout);
#endif	/*DEBUG*/
	}
}

void partsRefresh(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	if(parts != NULL) {
		partsRenewal(parts);
	}
}

/***************************************************************************
 *	partsMap: åȤޥåפ
 *	
 *		void partsMap(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void partsMap(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	if(parts != NULL) {
		parts->mapping = True;
		if((parts->partsWidget != NULL)?
					(XtIsRealized(parts->partsWidget)):(False)) {
			XtMapWidget(parts->partsWidget);
		}
	}
}

/***************************************************************************
 *	partsUnmap: åȤ򥢥ޥåפ
 *	
 *		void partsUnmap(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void partsUnmap(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	if(parts != NULL) {
		parts->mapping = False;
		if((parts->partsWidget != NULL)?
					(XtIsRealized(parts->partsWidget)):(False)) {
			XtUnmapWidget(parts->partsWidget);
		}
	}
}

/***************************************************************************
 *	partsMapAuto: ޥåפ뤫ɤϡåȤǤ
 *	
 *		void partsMapAuto(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void partsMapAuto(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	if(parts != NULL) {
		parts->mapping = EOF;
	}
}

/***************************************************************************
 *	partsPopup: ꤵ줿ʤݥåץåפ
 *	
 *		void partsPopup(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsPopup(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popupShell;
	Position x, y;
	Dimension width, height;
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	popupShell = parts->partsWidget;
	if(popupShell != NULL && XtIsShell(popupShell)) {
		/***********************************
		 *	Root Window κɸϤѴ
		 ***********************************/
		XtTranslateCoords(XtParent(popupShell),		/* Widget */
							(Position) 0,			/* x */
							(Position) 0,			/* y */
							&x, &y);				/* coords on root window */
		/*******************************************************************
		 *	ݥåץåץΰ֤ꤹʤޤвƤʤ
		 *******************************************************************/
		XtVaSetValues(popupShell, XtNx, x, XtNy, y, NULL);

		XtPopup(popupShell, XtGrabNone);
#ifdef	DEBUG
	} else {
		printf("partsPopup():Widget=%p,XtIsRealized()=%d,XtIsShell()=%d\n", 
				popupShell, XtIsRealized(popupShell), XtIsShell(popupShell));
#endif	/*DEBUG*/
	}
}

/***************************************************************************
 *	partsPopdown: ꤵ줿ʤݥåץ󤹤
 *	
 *		void partsPopdown(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popdownShell;
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	popdownShell = parts->partsWidget;
	if(popdownShell != NULL && 
			XtIsRealized(popdownShell) && XtIsShell(popdownShell)) {
		XtPopdown(popdownShell);
	}
}

/***************************************************************************
 *	saveFileLineեˣ¸
 *	
 *		void saveFileLine(const char *string);
 *	
 *		const char *string;		ե¸ʸ
 *	
 *		
 ***************************************************************************/
void saveFileLine(const char *string)
{
	fprintf(save_fp, "%s\n", string);
}

/***************************************************************************
 *	copyBufferLineԡХåեˣ¸
 *	
 *		void copyBufferLine(const char *string);
 *	
 *		const char *string;		ԡХåե¸ʸ
 *	
 *		
 ***************************************************************************/
void copyBufferLine(const char *string)
{
	copyBufferList = stringConnect(copyBufferList, stringsAlloc(string));
}

/***************************************************************************
 *	treeList: ʣĤʥĥ꡼եسǼ
 *	
 *		void treeList(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;		եسǼ
 *		XtPointer client_data;	
 *	֤
 *		
 *	
 *		δؿϡʣʬʥĥ꡼եسǼ뤿
 *		ؿǤ롣
 *		δؿ PartsTopTrace() ʲΤ褦ˤȡ
 *		
 *		    PartsTopTrace(partsRoot, treeList);   
 *		      partsRoot  ʥĥ꡼κ 
 *		      treeList   δؿ 
 *		
 *		ʥĥ꡼Τ¸Ǥ롣
 *		
 ***************************************************************************/
void treeList(PartsTree *parts, XtPointer client_data)
{
	int counter;
	int length = 0;
	char stringBuffer[1024];
	PartsTree *parts_ptr;
	void (*saveLineProc)(const char *string) = (void (*)())client_data;

	for(counter = 0, parts_ptr = parts;parts_ptr->parent_ptr != NULL;
							parts_ptr = parts_ptr->parent_ptr, ++counter) {
		length += sprintf(stringBuffer+length, "\t");
	}
	if(counter == 0) {
		length += sprintf(stringBuffer+length, "%c%s  %s", 
			toupper(*parts->widgetName), 
			parts->widgetName+(*parts->widgetName != '\0'), parts->widgetName);
	} else {
		length += sprintf(stringBuffer+length, "%s  %s", 
							parts->athenaInfo->className, parts->widgetName);
	}
	if(parts->variableName != NULL && 
				strcmp(parts->widgetName, parts->variableName) != 0) {
		length += sprintf(stringBuffer+length, "%s", parts->variableName);
	}
	switch(parts->mapping) {
	case True:
		length += sprintf(stringBuffer+length, "  [map]");
		break;
	case False:
		length += sprintf(stringBuffer+length, "  [unmap]");
		break;
	case EOF:
		break;
	}
	saveLineProc(stringBuffer);
}

/***************************************************************************
 *	partsTreeSave: ʥĥ꡼¸
 *	
 *		void partsTreeSave(PartsTree *parts, FILE *fp)
 *	
 *		PartsTree *parts;		ʥĥ꡼κ
 *		FILE *fp;				¸եΥեݥ
 *	
 *		
 ***************************************************************************/
void partsTreeSave(PartsTree *parts, FILE *fp)
{
	save_fp = fp;
	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;
	
	PartsTopTrace2(parts, (XtPointer)saveFileLine, treeList);
}

/***************************************************************************
 *	partsTreeCopy: ʥĥ꡼򥳥ԡХåե¸
 *	
 *		void partsTreeCopy(PartsTree *parts, FILE *fp)
 *	
 *		PartsTree *parts;		ʥĥ꡼κ
 *		FILE *fp;				¸եΥեݥ
 *	
 *		
 ***************************************************************************/
void partsTreeCopy(PartsTree *parts)
{
	stringRelease(copyBufferList);
	copyBufferList = NULL;
	PartsTopTrace2(parts, (XtPointer)copyBufferLine, treeList);
}

/***************************************************************************
 *	searchClassName饹̾饯饹ˤĤƤξ
 *	
 *		AWidgetInfo *searchClassName(const char *className);
 *	
 *		const char *className;		饹̾
 *	֤
 *		NULL:		륯饹󤬸Ĥʤä
 *		NULLʳ:	줿饹
 *	
 *		
 ***************************************************************************/
AWidgetInfo *searchClassName(const char *className)
{
	int counter;
	int limit;
	AWidgetInfo *result_ptr;

	limit = sizeof(widgetSet)/sizeof(widgetSet[0]);
	for(counter = 0, result_ptr = NULL;
					counter < limit && result_ptr == NULL;++counter) {
		if(strcmp(widgetSet[counter].className, className) == 0) {
			result_ptr = &widgetSet[counter];
		}
	}
	return(result_ptr);
}

/***************************************************************************
 *	youngestInLevelꤵ줿ŪʿƻҴطǰּ㤤ʤõ
 *	
 *		PartsTree *youngestInLevel(PartsTree *nodeParts, int relativeLevel);
 *	
 *		PartsTree *nodeParts;	
 *		int relativeLevel;		ƻҴطʲλ¹򼨤
 *	֤
 *		NULL:		ꤵ줿ŪʿƻҴطȯǤʤä
 *		NULLʳ:	ꤵ줿ŪʿƻҴطǰּ㤤ʤ֤
 *	
 *	
 ***************************************************************************/
PartsTree *youngestInLevel(PartsTree *nodeParts, int relativeLevel)
{
	int exitFlag;
	int level = 0;
	PartsTree *youngestParts = NULL;

	if(relativeLevel >= 0) {
		youngestParts = nodeParts;
		do {
			exitFlag = TRUE;
			youngestParts = youngestBrother(youngestParts);
			if(youngestParts->child_ptr != NULL) {
				if(level < relativeLevel) {
					level++;
					youngestParts = youngestParts->child_ptr;
					exitFlag = FALSE;
				}
			}
		} while(exitFlag == FALSE);
	}
	
	return((relativeLevel == level)?(youngestParts):(NULL));
}

/***************************************************************************
 *	stringSearchʸ˰פʸ󤬤뤫ɤȽꤹ
 *	
 *		int stringSearch(const char *commandLine, const char **commands);
 *	
 *		const char *commandLine;	о
 *		const char **commands;		ʸʤNULLݥ󥿤ǽ
 *	֤
 *		EOF: 	פʸ¸ߤʤ
 *		0ʾ: 	פʸֹ
 *	
 *		ʸ˰פʸ󤬤뤫ɤȽꤹ
 ***************************************************************************/
int stringSearch(const char *commandLine, const char **commands)
{
	int status = EOF;
	int counter;

	for(counter = 0;*(commands+counter) != NULL && status != 0;++counter) {
		status = strcmp(commandLine, *(commands+counter));
	}
	return((status == 0)?(counter-1):(EOF));
}

/***************************************************************************
 *	setPartsOption: 
 *	
 *		void setPartsOption(PartsTree *newParts, const char *optionLine);
 *	
 *		PartsTree *newParts;	
 *		const char *optionLine;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void setPartsOption(PartsTree *newParts, const char *optionLine)
{
	int status;
	int readPoint = 0;
	char optionsString[20];
	static const char *commands[] = {"[map]" , "[unmap]", NULL};
	enum commadCode {map, unmap};

	do {
		status = sscanf(optionLine+readPoint, "%s%n", optionsString, &readPoint);
		if(status > 0) {
			switch(optionsString[0]) {
			case '[':
				switch(stringSearch(optionsString, commands));
				case EOF:
					break;
				case map:
					newParts->mapping = True;
					break;
				case unmap:
					newParts->mapping = False;
					break;
				break;
			default:
				if(isalpha(optionsString[0])) {
					newParts->variableName = XtNewString(optionsString);
				}
				break;
			}
		}
	} while(status == 2);
}

/***************************************************************************
 *	getTreeListʥǡե뤫ɤ߹
 *	
 *		PartsTree *getTreeList(PartsTree *parts, FILE *fp);
 *	
 *		PartsTree *parts;	ʥĥ꡼κ
 *		FILE *fp;			եݥ
 *	֤
 *		NULL:		顼ʥ­
 *		NULLʳ:	ʥǡ
 *	
 *	
 ***************************************************************************/
PartsTree *getTreeList(PartsTree *parts, const char *line_ptr)
{
	int newLevel;
	int optionPoint;
	char *indent_ptr;
	char className[20], widgetName[50];
	PartsTree *parts_ptr, *node;
	PartsTree *newParts = NULL;
	AWidgetInfo *classInfo;

	if(line_ptr != NULL) {
		for(newLevel = 0;*line_ptr == '\t';++newLevel, ++line_ptr)
			;						/*  */
		sscanf(line_ptr, "%19s%49s%n", 
					className, widgetName, &optionPoint);
#ifdef	DEBUG
		printf("%s [%s] -- %d\n", widgetName, className, newLevel);
#endif	/*DEBUG*/
		
		classInfo = searchClassName(className);
		if(classInfo == NULL && newLevel == 0) {
			classInfo = searchClassName("ApplicationShell");
			readAppdefaultFile(className);
		}
		if((classInfo != NULL)?(classInfo->instance != NULL):(False)) {
			node = youngestInLevel(parts, newLevel - 1);
			newParts = partsAppend(node, widgetName, classInfo);
			setPartsOption(newParts, line_ptr+optionPoint);
			if(newLevel > 0) {
				(void)partsChildLink(node, newParts);
			} else {
				newParts->className = XtNewString(className);
			}
			if(newParts->variableName == NULL) {
				variableNaming(newParts, widgetName);
			}
		}
	}
	return(newParts);
}

/***************************************************************************
 *	partsTreeInit: ʥĥ꡼ɤ߹
 *	
 *		void partsTreeInit(PartsTree **parts_ptr_ptr);
 *	
 *		PartsTree **parts_ptr_ptr;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void partsTreeInit(PartsTree **parts_ptr_ptr)
{
	PartsTree *parts = NULL;
	
	if(parts_ptr_ptr != NULL) {
		if(*parts_ptr_ptr != NULL) {
			parts = *parts_ptr_ptr;
			while(parts->parent_ptr != NULL)
				parts = parts->parent_ptr;
		}
		XtVaSetValues(mguiTree, XtNautoReconfigure, False, NULL);
		PartsBottomTrace(parts, partsUnlinkAndFree);	/* ¸ʤ˴ */
		parts = *parts_ptr_ptr = NULL;
	}
}
 
/***************************************************************************
 *	partsClearAll
 *	
 *		void partsClearAll(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;					̤
 *		XtPointer client_data;		ʾ
 *		XtPointer call_data;		̤
 *	
 *	
 ***************************************************************************/
void partsClearAll(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree **parts_ptr_ptr = 		/* ʾ */
			(PartsTree **)((struct menu_data*)client_data)->client_data;

	partsTreeInit(parts_ptr_ptr);
	makableObject(*parts_ptr_ptr);	/* ǽʥåȤΥꥹȤ */
}

/***************************************************************************
 *	partsTreeLoad: ʥĥ꡼ɤ߹
 *	
 *		void partsTreeLoad(PartsTree **parts_ptr_ptr, FILE *fp);
 *	
 *		PartsTree **parts_ptr_ptr;
 *		FILE *fp;					ʥĥ꡼ɤ߹եݥ
 *	֤
 *		
 *	
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 ***************************************************************************/
void partsTreeLoad(PartsTree **parts_ptr_ptr, FILE *fp)
{
	PartsTree *parts = NULL;
	PartsTree *newParts;
	char lineBuffer[4096], *line_ptr;
	
	save_fp = fp;
	if(parts_ptr_ptr != NULL) {
		if(*parts_ptr_ptr != NULL) {
			parts = *parts_ptr_ptr;
			while(parts->parent_ptr != NULL)
				parts = parts->parent_ptr;
		}
		XtVaSetValues(mguiTree, XtNautoReconfigure, False, NULL);
		PartsBottomTrace(parts, partsUnlinkAndFree);	/* ¸ʤ˴ */
		parts = *parts_ptr_ptr = NULL;
		while(feof(fp) == 0 && ferror(fp) == 0) {
			line_ptr = fgets(lineBuffer, sizeof(lineBuffer), fp);
			/*printf("%s\n", line_ptr);*/
			newParts = getTreeList(parts, line_ptr); /*	ʥեɤ */
			if(newParts != NULL) {
				if(*parts_ptr_ptr == NULL) {
					*parts_ptr_ptr = parts = newParts;
				}
			}
		}
		if(parts != NULL) {
			partsRenewal(parts);
		}
		XawTreeForceLayout(mguiTree);
		XtVaSetValues(mguiTree, XtNautoReconfigure, True, NULL);
	}
}
 
/***************************************************************************
 *	partsTreePaste: ʥĥ꡼ɤ߹
 *	
 *		void partsTreePaste(PartsTree **parts_ptr_ptr, String pasteBuffer);
 *	
 *		PartsTree **parts_ptr_ptr;
 *		String pasteBuffer;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void partsTreePaste(PartsTree **parts_ptr_ptr, String pasteBuffer)
{
	PartsTree *parts = NULL;
	PartsTree *newParts;
	StringsLink *strings, *string_ptr;
	
	strings = stringsAlloc(pasteBuffer);
	if(parts_ptr_ptr != NULL) {
		if(*parts_ptr_ptr != NULL) {
			parts = *parts_ptr_ptr;
			while(parts->parent_ptr != NULL)
				parts = parts->parent_ptr;
		}
		PartsBottomTrace(parts, partsUnlinkAndFree);	/* ¸ʤ˴ */
		parts = *parts_ptr_ptr = NULL;
		for(string_ptr = strings;string_ptr != NULL;
									string_ptr = string_ptr->next_ptr) {
			newParts = getTreeList(parts, string_ptr->string);
			if(newParts != NULL) {
				if(*parts_ptr_ptr == NULL) {
					*parts_ptr_ptr = parts = newParts;
				}
			}
		}
		if(parts != NULL) {
			partsRenewal(parts);
		}
	}
	stringRelease(strings);
}
 
/***************************************************************************
 *	noArgذʤ١Ѥδؿ
 *	
 *		char *noArg(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ̤ѡ
 *	֤
 *		ˡʸؤΥݥ
 *	
 *		ذʤ١źѤδؿ
 *		ذνüѡ٤бʸ뤿Τºݤ
 *		̤ѤƱˤʤ롣
 ***************************************************************************/
char *noArg(PartsTree *parts)
{
	return("");
}

/***************************************************************************
 *	argWidgetإåѿ̾١Ѥδؿ
 *	
 *		char *argWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *		åѿ̾
 *	
 *	
 ***************************************************************************/
char *argWidget(PartsTree *parts)
{
	char *widgetVariable = "";

	if(parts != NULL) {
		if(parts->variableName != NULL) {
			widgetVariable = parts->variableName;
		} else {
			if(parts->widgetName != NULL) {
				widgetVariable = parts->widgetName;
			}
		}
	}
	return(widgetVariable);
}

/***************************************************************************
 *	argWidgetNameإå̾١Ѥδؿ
 *	
 *		char *argWidgetName(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *		NULL:		顼
 *		NULLʳ:	å̾
 *	
 *	
 ***************************************************************************/
char *argWidgetName(PartsTree *parts)
{
	char *widgetName = "";

	if(parts != NULL) {
		widgetName = parts->widgetName;
	};
	return(widgetName);
}

/***************************************************************************
 *	argWidgetClassإ饹ѿ̾١Ѥδؿ
 *	
 *		char *argWidgetClass(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *	
 *	
 ***************************************************************************/
char *argWidgetClass(PartsTree *parts)
{
	const char *className = "";

	if(parts != NULL) {
		if(parts->athenaInfo != NULL) {
			if(parts->athenaInfo->variableName != NULL) {
				className = parts->athenaInfo->variableName;
			}
		}
	}
	return((char*)className);
}

/***************************************************************************
 *	argClassNameإ饹̾١Ѥδؿ
 *	
 *		char *argClassName(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *	
 *		إ饹̾٤ϡȤƤϡȤͽϤʤ
 *		ϡĥ꡼åȺѤ˻Ȥ
 ***************************************************************************/
char *argClassName(PartsTree *parts)
{
	const char *className = "";

	if(parts != NULL) {
		if(parts->className != NULL) {
			className = parts->className;
		} else {
			if(parts->athenaInfo != NULL) {
				if(parts->athenaInfo->className != NULL) {
					className = parts->athenaInfo->className;
				}
			}
		}
	}
	return((char*)className);
}

/***************************************************************************
 *	argParentؿƥåѿ̾١Ѥδؿ
 *	
 *		char *argParent(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *	
 *	
 ***************************************************************************/
char *argParent(PartsTree *parts)
{
	char *parent = "";

	if(parts != NULL) {
		if(parts->parent_ptr != NULL) {
			parent = argWidget(parts->parent_ptr);
		}
	}
	return(parent);
}

/***************************************************************************
 *	argWidgetClassإ饹ѿ̾ٺѤδؿ
 *	
 *		char *argWidgetClass(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *	
 *	
 ***************************************************************************/
char *widgetAndClassName(PartsTree *parts)
{
	char *widgetName, *className;
	static char names[40];

	widgetName = argWidgetName(parts);
	className  = argClassName(parts);
	sprintf(names, "%s/%s", widgetName, className);
	return(names);
}

/***************************************************************************
 *	widgetAndVariableإ/ѿ̾ɽѤδؿ
 *	
 *		char *widgetAndVariable(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *	
 *	
 ***************************************************************************/
char *widgetAndVariable(PartsTree *parts)
{
	static char names[40];
	char *widgetName, *variableName;

	widgetName = argWidgetName(parts);
	variableName  = argWidget(parts);
	sprintf(names, "%s/%s", widgetName, variableName);
	return(names);
}

/***************************************************************************
 *	argAppContextإץꥱ󥳥ƥѿ̾١Ѥδؿ
 *	
 *		char *argAppContext(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *		ˡ"app_context" 
 *	
 *	
 ***************************************************************************/
char *argAppContext(PartsTree *parts)
{
	return("app_context");
}

/***************************************************************************
 *	argApplicationClassإץꥱ󥯥饹̾١Ѥδؿ
 *	
 *		char *argApplicationClass(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *		
 *	
 *		ץꥱ󥯥饹̾դ롼˽äƺ롣
 *	
 ***************************************************************************/
char *argApplicationClass(PartsTree *parts)
{
	static char className[40];

	/* ʥĥ꡼κ򸡺 */
	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;
	
	if(parts != NULL) {
		sprintf(className, "%c%s", toupper(*parts->widgetName), 
				parts->widgetName+(*parts->widgetName != '\0'));
	}
	return(className);
}

/***************************************************************************
 *	argDummyClassNameإߥ졼ѥ饹Υ饹̾١Ѥδؿ
 *	
 *		char *argDummyClassName(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ
 *	֤
 *		
 *	
 *		إߥ졼ѥ饹ݥ󥿤Υ饹̾١Ѥδؿ
 *		إ饹̾٤ϡȤƤϡȤͽϤʤ
 *		ϡĥ꡼åȺѤ˻Ȥ
 ***************************************************************************/
char *argDummyClassName(PartsTree *parts)
{
	const char *className = "";

	if(parts != NULL && parts->athenaInfo != NULL && 
								parts->athenaInfo->partsClass != NULL) {
		className = parts->athenaInfo->className;
		if(strcmp(className, "ApplicationShell") == 0) {
			className = "TopLevelShell";	/* ApplicationShell㳰 */
		}
	}
	return((char*)className);
}

/***************************************************************************
 *	stringAlloc: ʬΥݤ
 *	
 *		StringsLink *stringAlloc(const char *string);
 *	
 *		const char *string;		ݤֹʬΥ˳Ǽʸ
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		ʬΥݤ롣
 *		
 ***************************************************************************/
StringsLink *stringAlloc(const char *string)
{
	StringsLink *alloc_ptr = NULL;
	
	alloc_ptr = (StringsLink*)XtMalloc(sizeof(StringsLink));
	if(alloc_ptr != NULL) {
		if(string != NULL) {
			alloc_ptr->string = XtNewString(string);
		} else {
			alloc_ptr->string = NULL;
		}
		alloc_ptr->next_ptr = NULL;
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	stringFree: ʸѤΥ
 *	
 *		void stringFree(StringsLink *lyric);
 *	֤
 *		StringsLink *lyric;		ʸ󥯥ȥꥹȤΥ
 *	
 *		
 ***************************************************************************/
void stringFree(StringsLink *release_ptr)
{
	if(release_ptr != NULL) {
#ifdef	DEBUG
		printf("%s\n", release_ptr->string);
#endif	/*DEBUG*/
		XtFree(release_ptr->string);
		XtFree((char*)release_ptr);
	}
}

/***************************************************************************
 *	stringRelease: ʸѤΥ
 *	
 *		void stringRelease(StringsLink *string);
 *	֤
 *		StringsLink *string;	ʸ󥯥ȥꥹȤΥ
 *	
 *		
 ***************************************************************************/
void stringRelease(StringsLink *string)
{
	StringsLink *release_ptr;
	
	while(string != NULL) {
		release_ptr = string;
		string = string->next_ptr;
		stringFree(release_ptr);
	}
}

/***************************************************************************
 *	stringsAlloc: ԰ʾΥݤ
 *	
 *		StringsLink *stringsAlloc(const char *string);
 *	
 *		const char *string;		ݤֹʬΥ˳Ǽʸ
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		ʬΥݤ롣
 *		
 ***************************************************************************/
StringsLink *stringsAlloc(const char *string)
{
	int length;
	int loopExit = True;
	const char *line_ptr, *line_end_ptr;
	StringsLink *alloc_ptr = NULL, *allocTop;

	line_ptr = string;
	allocTop = alloc_ptr = stringAlloc(NULL);
	do {
		loopExit = True;
		line_end_ptr = strchr(line_ptr, '\n');
		length = ((line_end_ptr != NULL)?
							(line_end_ptr-line_ptr):(strlen(line_ptr)));
		alloc_ptr->string = (char*)XtMalloc(length+1);
		if(alloc_ptr->string != NULL) {
			sprintf(alloc_ptr->string, "%.*s", length, line_ptr);
#ifdef	DEBUG
			printf("%s\n", alloc_ptr->string);	fflush(stdout);
#endif	/*DEBUG*/
			alloc_ptr->next_ptr = stringAlloc(NULL);
		}
		if(line_end_ptr != NULL && alloc_ptr->next_ptr != NULL) {
			line_ptr = line_end_ptr + (*line_end_ptr == '\n');
			alloc_ptr = alloc_ptr->next_ptr;
			loopExit = False;
		}
	} while(loopExit == False);
	XtFree((char*)alloc_ptr->next_ptr);
	alloc_ptr->next_ptr = NULL;
	return(allocTop);
}

/***************************************************************************
 *	stringConnect: ʸ󥯤Υ
 *	
 *		StringsLink *stringConnect(StringsLink *strings1, 
 *										StringsLink *strings2);
 *	
 *		StringsLink *strings1;
 *		StringsLink *strings2;
 *	֤
 *		ʸ󥯤Ƭ
 *	
 *		
 ***************************************************************************/
StringsLink *stringConnect(StringsLink *strings1, StringsLink *strings2)
{
	StringsLink *string_ptr;

	if(strings1 != NULL) {
		string_ptr = strings1;
		while(string_ptr->next_ptr != NULL) {
			string_ptr = string_ptr->next_ptr;
		}
		string_ptr->next_ptr = strings2;
	} else {
		strings1 = strings2;
	}
	return(strings1);
}

/***************************************************************************
 *	partsCollection륦åȤμ̾
 *	
 *		void partsCollection(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;	ʴ
 *		XtPointer client_data;
 *	
 *		륦åȤμ̾ޤ
 *		ϡѥ֥å󥯥롼ɡեΤɬס
 ***************************************************************************/
void partsCollection(PartsTree *parts, XtPointer client_data)
{
	int partsId;
	int *classArray = (int*)client_data;

	if(parts->athenaInfo != NULL) {
		partsId = parts->athenaInfo->id;
#ifdef	DEBUG
		printf("%s %s[%d]\n", 
				parts->athenaInfo->className, parts->widgetName, partsId);
#endif	/*DEBUG*/
		*(classArray+partsId) = True;
	}
}

/***************************************************************************
 *	partsIncludeѥ֥å󥯥롼ɡե
 *	
 *		void partsInclude(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;		ʤξ
 *		XtPointer client_data;	ʤμ̾
 *	
 *	
 ***************************************************************************/
void partsInclude(PartsTree *parts, XtPointer client_data)
{
	int partsId;
	int *classArray = (int*)client_data;

	if(parts->athenaInfo != NULL) {
		partsId = parts->athenaInfo->id;
		if(*(classArray+partsId)) {
			sourceList = stringConnect(sourceList, 
						stringsAlloc(parts->athenaInfo->publicInclude));
			*(classArray+partsId) = False;
		}
	}
}

/***************************************************************************
 *	partsVariableåɬפѿ
 *	
 *		void partsVariable(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;		ʤξ
 *		XtPointer client_data;	ѿιԤʸ
 *	
 *		
 *	
 ***************************************************************************/
void partsVariable(PartsTree *parts, XtPointer client_data)
{
	int length;
	char *variable_ptr;
	char *variableDefinition = (char*)client_data;

	length = strlen(variableDefinition);
	variable_ptr = variableDefinition + length;
	if((strlen(variableDefinition) + length) > 60) {
		sprintf(variable_ptr, "%s %s;", 
				((length == 0)?("\tWidget"):("")), parts->widgetName);
		/*printf("%s\n", variableDefinition);*/
		sourceList = 
				stringConnect(sourceList, stringsAlloc(variableDefinition));
		*variableDefinition = '\0';
	} else {
		sprintf(variable_ptr, "%s %s,", 
				((length == 0)?("\tWidget"):("")), parts->widgetName);
	}
}

/***************************************************************************
 *	partsCoding: Widget ˴ؤƥեޥåȲʸȰ饳ǥ
 *	
 *		void partsCoding(PartsTree *parts, 
 *								const char *format, int *argumentsInfo);
 *	
 *		PartsTree *parts;	 Widget ˴ؤ
 *		const char *format;	եޥåȲʸsprintf() ΤΡ
 *		int *argumentsInfo;	򵭤
 *	
 *		Widget ˴ؤƥեޥåȲʸȰ󤫤饳ǥ󥰤
 *	
 ***************************************************************************/
void partsCoding(PartsTree *parts, const char *format, int *argumentsInfo)
{
	int counter;
	int argumentType;
	char *arguments[10];
	char stringBuffer[1024];

	/*******************************
	 *	ؿΰʬ
	 *******************************/
	for(counter = 0;counter < 10;++counter)
		arguments[counter] = "";

	/*************************
	 *	ؿΰʬ
	 *************************/
	if(parts != NULL && format != NULL && argumentsInfo != NULL) {
		for(counter = 0;*(argumentsInfo+counter) != NoArg;++counter) {
			argumentType = *(argumentsInfo+counter);
			/*printf("argument#%d's type = %d.\n", counter, argumentType);*/
			if(argumentType > NoArg && argumentType < VariableTypeNum) {
				arguments[counter] = argumentArrayProc[argumentType](parts);
			}
		}
		/****************************************
		 *	Widget κʬ򥳡ǥ󥰤
		 ****************************************/
		sprintf(stringBuffer, format, arguments[0], arguments[1], 
				arguments[2], arguments[3], arguments[4], arguments[5], 
				arguments[6], arguments[7], arguments[8], arguments[9]);
		sourceList = stringConnect(sourceList, stringsAlloc(stringBuffer));
	}
}

/***************************************************************************
 *	partsCreateCoding: Widget ʬ򥳡ǥ󥰤
 *	
 *		void partsCreateCoding(PartsTree *parts);
 *	
 *		PartsTree *parts;	 Widget ˴ؤ
 *	
 *	
 ***************************************************************************/
void partsCreateCoding(PartsTree *parts)
{
	if(parts != NULL && parts->athenaInfo != NULL && 
							parts->athenaInfo->argTypes != NULL) {
		partsCoding(parts, 
				parts->athenaInfo->instance, parts->athenaInfo->argTypes);
	}
}

/***************************************************************************
 *	stringsLinkLength: ʸ󥯥ȥꥹȤʸ򥫥Ȥ
 *	
 *		int stringsLinkLength(StringsLink *strings);
 *	֤
 *		ʸ󥯥ȥꥹȤʸ
 *	
 *		
 ***************************************************************************/
int stringsLinkLength(StringsLink *strings)
{
	int counter;
	
	counter = 0;
	while(strings != NULL) {
		counter += strlen(strings->string) + 1;
		strings = strings->next_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	stringsLink2string: ʸ󥯤ʸѴ
 *	
 *		String stringsLink2string(StringsLink *strings);
 *	
 *		StringsLink *strings;
 *	֤
 *		NULL:		顼ʥ­
 *		NULLʳ:	Ѵ줿ʸ
 *	
 *		
 ***************************************************************************/
String stringsLink2string(StringsLink *strings)
{
	int counter;
	size_t length;
	String textString;
	
	length = stringsLinkLength(strings);
	textString = XtMalloc(length + 1);
	for(counter = 0, *textString = '\0';strings != NULL && 
			(counter+strlen(strings->string)+1) <= length;
			counter+=strlen(strings->string)+1, strings=strings->next_ptr) {
		strcat(textString, strings->string);
		if(strings->next_ptr != NULL)
			strcat(textString, "\n");
	}
	return(textString);
}

/***************************************************************************
 *	makeSourceøΥե
 *	
 *		void makeSource(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;					̤
 *		XtPointer client_data;		ʾ
 *		XtPointer call_data;		̤
 *	
 *	
 ***************************************************************************/
void makeSource(Widget w, XtPointer client_data, XtPointer call_data)
{
	int counter;		/* 롼ץ */
	int numOfClass;		/* 饹ĥåȿǼѿ */
	int length;			/* ʸĹ */
	int *classArray;	/* 饹̤ǻѤ̵ͭĴ٤뤿 */
	int argumentsInfo[] = {ArgWidget, NoArg};	/* XtRealize() ΰ */
	char stringBuffer[80];	/* ʸХåե */
	PartsTree *parts = 		/* ʾ */
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	extern Widget mguiSourceShell, mguiSourceArea, mguiSourceTools;
	extern Widget mguiPopdown, mguiSave, mguiLoad, mguiSourceFile, mguiSourceText;

	XtPopup(mguiSourceShell, XtGrabNonexclusive);
	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;

	/***********************************************
	 *	ѥ֥å󥯥롼ɥեʬκ
	 ***********************************************/
	numOfClass = sizeof(widgetSet)/sizeof(widgetSet[0]);
	classArray = (int*)XtMalloc(sizeof(int) * numOfClass);
	if(classArray != NULL) {
		/*
		 *	
		 */
		for(counter = 0;counter < numOfClass;++counter)
			*(classArray+counter) = False;
		PartsTopTrace2(parts, (XtPointer)classArray, partsCollection);
		PartsTopTrace2(parts, (XtPointer)classArray, partsInclude);
		XtFree((char*)classArray);
		sourceList = stringConnect(sourceList, 
					stringsAlloc("\nvoid main(int argc, char **argv)\n{"));
		sourceList = stringConnect(sourceList, 
							stringsAlloc("\tXtAppContext app_context;"));
	}
	/**********************
	 *	Widget ѿ
	 **********************/
	stringBuffer[0] = '\0';
	PartsTopTrace2(parts, (XtPointer)stringBuffer, partsVariable);
	length = strlen(stringBuffer);
	if(length > 0) {
		sprintf(stringBuffer, "%.*s;\n", length-1, stringBuffer);
		sourceList = stringConnect(sourceList, stringsAlloc(stringBuffer));
	}
	/******************
	 *	Widget ι
	 ******************/
	PartsTopTrace(parts, partsCreateCoding);
	/**********************
	 *	Widget μֺ
	 **********************/
	partsCoding(parts, "\tXtRealizeWidget(%s);", argumentsInfo);
	/*printf("\tXtAppMainLoop(app_context);\n}");*/
	sourceList = stringConnect(sourceList, 
					stringsAlloc("\tXtAppMainLoop(app_context);\n}\n"));
	XtVaSetValues(mguiSourceText, 
					XtNstring, stringsLink2string(sourceList), NULL);
	stringRelease(sourceList);
	sourceList = NULL;
}

/***************************************************************************
 *	widgetInitwidgetSet μֹ(ID)
 *	
 *		void widgetInit(void);
 *	
 *	
 ***************************************************************************/

void widgetInit(void)
{
	int counter, numOfClass;

	/***********************************************
	 *	ѥ֥å󥯥롼ɥեʬκ
	 ***********************************************/
	numOfClass = sizeof(widgetSet)/sizeof(widgetSet[0]);
	for(counter = 0;counter < numOfClass;++counter) {
		widgetSet[counter].id = counter;
	}
}

/***************************************************************************
 *	partsLabelSet: ĥ꡼ʤ˻ꤵ줿ǥ٥ĥդ
 *	
 *		void partsLabelSet(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;	ʴ
 *		XtPointer client_data;
 *	
 *		
 ***************************************************************************/
void partsLabelSet(PartsTree *parts, XtPointer client_data)
{
	char *(*labelProc)(PartsTree *parts) = 
									(char *(*)(PartsTree *))client_data;

	defaultLabel = labelProc;
	XtVaSetValues(parts->treeWidget, XtNlabel, labelProc(parts), NULL);
}

/***************************************************************************
 *	partsWidgetVariable: 
 *	
 *		void partsWidgetVariable(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsWidgetVariable(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	PartsTopTrace2(rootParts(parts), 
							(XtPointer)widgetAndVariable, partsLabelSet);
	XawTreeForceLayout(mguiTree);
}

/***************************************************************************
 *	partsWidgetName: 
 *	
 *		void partsWidgetName(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsWidgetName(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	PartsTopTrace2(rootParts(parts), 
							(XtPointer)argWidgetName, partsLabelSet);
	XawTreeForceLayout(mguiTree);
}

/***************************************************************************
 *	partsClassNames: 
 *	
 *		void partsClassNames(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsClassNames(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	PartsTopTrace2(rootParts(parts), 
							(XtPointer)argClassName, partsLabelSet);
	XawTreeForceLayout(mguiTree);
}

/***************************************************************************
 *	partsWidgetAndClassNames: 
 *	
 *		void partsWidgetAndClassNames(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsWidgetAndClassNames(Widget w, 
							XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	PartsTopTrace2(rootParts(parts), 
						(XtPointer)widgetAndClassName, partsLabelSet);
	XawTreeForceLayout(mguiTree);
}

/***************************************************************************
 *	partsResourceBox: 
 *	
 *		void partsResourceBox(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsResourceBox(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	makeResourceBox(parts);
}

/***************************************************************************
 *	samenameCheck: ͡ॷޤ
 *	
 *		XtPointer samenameCheck(PartsTree *parts);
 *	
 *		PartsTree *parts;			ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
XtPointer samenameCheck(PartsTree *parts)
{
	int status = FALSE;
	
	if(parts != originalWidget.myParts) {
		if(parts->variableName != NULL) {
			status = (strcmp(parts->variableName, 
									originalWidget.newVariableName) == 0);
		} else {
			status = (strcmp(parts->widgetName, 
									originalWidget.newVariableName) == 0);
		}
	}
	return((status)?(parts):(NULL));
}

/***************************************************************************
 *	variableNaming: åѿ̾̾դԤ
 *	
 *		char *variableNaming(PartsTree *parts, String name_ptr);
 *	
 *		PartsTree *parts;		ʾ
 *		String name_ptr;		Ĥ̾̾ϥå̾
 *	֤
 *		NULL:		̾դ˼ԡʥ­Ʊ̾åȤ¿
 *		NULLʳ:	̿̾ѿ̾
 *	
 *		ʬϰʲ̤
 *	
 *	Ƥꨭ
 *		
 *		
 *		 widgetName 
 *		
 *		variableNameåȤѿ̾ʸ
 *		
 *		  className 
 *		
 *		 partsWidget
 *		
 *		 treeWidget 
 *		
 *		mapping ġ
 *		
 *		 athenaInfo 
 *		
 *		 parent_ptr 
 *		
 *		 child_ptr
 *		
 *		prev_ptr
 *		
 *		next_ptr
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
char *variableNaming(PartsTree *parts, String name_ptr)
{
	int namingCounter = 0;
	PartsTree *samenameParts = NULL, *rootParts_ptr;
	
	rootParts_ptr = rootParts(parts);		/* ĥ꡼¤κܤ */
	originalWidget.myParts = parts;			/* ѿ̾̿̾ʾ */
	originalWidget.newVariableName = XtMalloc(strlen(name_ptr) + 8);
	if(originalWidget.newVariableName != NULL) {
		do {
			if(namingCounter == 0) {
				sprintf(originalWidget.newVariableName, "%s", name_ptr);
			} else {
				sprintf(originalWidget.newVariableName, 
										"%s%d", name_ptr, namingCounter);
			}
			samenameParts = PartsSearch(rootParts_ptr, samenameCheck);
		} while(samenameParts != NULL && ++namingCounter < 65536);
		if(samenameParts != NULL) {
			XtFree(originalWidget.newVariableName);
			originalWidget.newVariableName = NULL;
		}
	}
	parts->variableName = originalWidget.newVariableName;
	return(originalWidget.newVariableName);
}

/***************************************************************************
 *	setRenames: ͡ह
 *	
 *		void setRenames(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	͡हʾ
 *		XtPointer call_data;	̤
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		͡ѥ		renameSet			ľܤΥХå
 *		ʥ						̾ѹ
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
void setRenames(Widget w, XtPointer client_data, XtPointer call_data)
{
	String newString;
	PartsTree *parts = *(PartsTree **)client_data;
	
	XtFree(parts->widgetName);
	XtFree(parts->variableName);

	XtVaGetValues(rWidgetName, XtNstring, &newString, NULL);
	if(newString != NULL) {
		parts->widgetName = XtNewString(newString);
	}
	/*
	 *	XtVaGetValues(rClassName, XtNstring, &newString, NULL);
	 *	if(newString != NULL) {
	 *		parts->widgetName = XtNewString(newString);
	 *	}
	 */
	XtVaGetValues(rVariableName, XtNstring, &newString, NULL);
	if(newString != NULL) {
		parts->variableName = XtNewString(newString);
	}
	XtVaSetValues(parts->treeWidget, XtNlabel, defaultLabel(parts), NULL);
}

/***************************************************************************
 *	setNames: ͡ν򤹤
 *	
 *		void setNames(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	͡ह
 *		XtPointer call_data;	̤
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ġ			mguiRename				ľܤΥХå
 *												
 *												mguiRename Ǥϡ
 *												ݥåץåפ̤
 *												ХåؿƤ
 *												ޤ
 *	
 *		
 *		ʲΥåȤ˥͡Τ˸ߤ̾ϿƤޤ
 *		
 *		rWidgetName:		å̾Υ͡ѤTextå
 *		rClassName:			͡Υ饹̾ɽѤTextå
 *		rVariableName:		ѿ̾Υ͡ѤTextå
 *		
 *	Х
 *		͡ࡾ뤬˸ƤӽФƤϤʤʤ
 *		͡ࡾ뤬˴줿˸ƤӽФƤ⤤ʤ
 *		
 ***************************************************************************/
/*ARGSUSED*/
void setNames(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = *(PartsTree **)client_data;
	
	XtVaSetValues( rWidgetName, XtNstring, 
									XtNewString(parts->widgetName), NULL);
	if(parts->className != NULL) {
		XtVaSetValues(rClassName, XtNstring, 
									XtNewString(parts->className), NULL);
		XawTextDisplayCaret(rClassName, True);
	} else {
		XtVaSetValues(rClassName, XtNstring, 
						XtNewString(parts->athenaInfo->className), NULL);
		XawTextDisplayCaret(rClassName, False);
	}
	if(parts->variableName != NULL) {
		XtVaSetValues(rVariableName, XtNstring, 
								XtNewString(parts->variableName), NULL);
	} else {
		XtVaSetValues(rVariableName, XtNstring, 
								XtNewString(parts->widgetName), NULL);
	}
}

/***************************************************************************
 *	createRenameShell: ͡ॷޤ
 *	
 *		void createRenameShell(Widget parent);
 *	
 *		Widget parent;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Widget createRenameShell(Widget parent)
{
	Widget renameShell, renameArea, renameBlock;
	Widget widgetname, classname, variablename;
	Widget renamePanel, renameSet, renamePopdown;
	extern Widget mguiRename;

	renameShell = XtVaCreatePopupShell(
				"renameShell",
				transientShellWidgetClass,
				parent,
				NULL);
				
	renameArea = XtVaCreateManagedWidget(
				"renameArea",
				panedWidgetClass,
				renameShell,
				NULL);

	renameBlock = XtVaCreateManagedWidget(
				"renameBlock",
				formWidgetClass,
				renameArea,
				NULL);

	widgetname = XtVaCreateManagedWidget(
				"widgetname",
				labelWidgetClass,
				renameBlock,
				NULL);

	rWidgetName = XtVaCreateManagedWidget(
				"widgetName",
				asciiTextWidgetClass,
				renameBlock,
				XtNeditType, XawtextEdit,
				NULL);

	classname = XtVaCreateManagedWidget(
				"classname",
				labelWidgetClass,
				renameBlock,
				NULL);

	rClassName = XtVaCreateManagedWidget(
				"className",
				asciiTextWidgetClass,
				renameBlock,
				XtNeditType, XawtextEdit,
				NULL);

	variablename = XtVaCreateManagedWidget(
				"variablename",
				labelWidgetClass,
				renameBlock,
				NULL);

	rVariableName = XtVaCreateManagedWidget(
				"variableName",
				asciiTextWidgetClass,
				renameBlock,
				XtNeditType, XawtextEdit,
				NULL);

	renamePanel = XtVaCreateManagedWidget(
				"renamePanel",
				boxWidgetClass,
				renameArea,
				NULL);

	renameSet = XtVaCreateManagedWidget(
				"renameSet",
				commandWidgetClass,
				renamePanel,
				NULL);

	renamePopdown = XtVaCreateManagedWidget(
				"renamePopdown",
				commandWidgetClass,
				renamePanel,
				NULL);

	renamePopdownInfo.shell_widget  = renameShell;
	renamePopdownInfo.enable_widget = mguiRename;
	XtAddCallback(renameSet, 
					XtNcallback, setRenames, &CurrentParts);
	XtAddCallback(renamePopdown, 
					XtNcallback, XtCallbackPopdown, &renamePopdownInfo);
	return(renameShell);
}

